<%@ page contentType = "text/html; charset=UTF-8" %>
<%@ page import="com.trend.iwss.gui.*" %>
<%@ page import="com.trend.api.administration.*" %>
<%@ taglib uri="http://jakarta.apache.org/taglibs/i18n-1.0" prefix="i18n" %>
<%@ page import="com.trend.iwss.policy.JdbcHelper"%>
<%@ page import="java.sql.ResultSet"%>
<%@ page import="java.sql.SQLException"%>
<%@ page import="java.sql.Timestamp"%>
<%@ page import="java.text.DateFormat"%>
<%@ page import="java.text.SimpleDateFormat"%>
<%@ page import="java.util.Date"%>
<%@ page import="java.util.TimeZone"%>

<i18n:bundle baseName="iwsvaHttp" id="bundleHttp" />
<i18n:bundle baseName="iwsvaCommon" id="bundleCommon" />
<%

if(Validation.CheckUser(request,response)!=1)
{
    response.sendRedirect("logon.jsp");
    return;
}

    AdministrationAccount accountinfo = (AdministrationAccount)request.getSession().getAttribute("AccountInfo"); 
    AdministrationRole roleinfo = null;
    int access = 0;
    if(accountinfo != null)
    {
        roleinfo = accountinfo.getRole();
        access = roleinfo.getAccessRightByKeyID(401);
        if (access == 0)
        {
            response.sendRedirect("logon.jsp");
            return;
        }
    }
    else
    {
        response.sendRedirect("logon.jsp");
        return;    
    }

response.setHeader("Pragma","no-cache");
response.setHeader("Cache-Control","no-cache");

String nothing = "";
String WorkPath = nothing;
String location_file_ini = nothing;
//String clientcert_handling = nothing;

WorkPath = IWSSUtil.CheckPathEndSlash( IWSSJNI.GetWorkPath() );
location_file_ini = WorkPath + "intscan.ini";
IWSSINI ini = new IWSSINI(location_file_ini);
String httpsSect = "https-scanning";
String logEntry = "";
String commonLog = "";

//clientcert_handling = ini.GetKeyValue(httpsSect, "clientcert_handling");
String enable_client_enhance = ini.GetKeyValue(httpsSect, "clientcert_handling_enhance");
System.out.println("enable_client_enhance :"+ enable_client_enhance);


int limit = 20;
int offset = 0;
String removesame="no";


DateFormat format = new SimpleDateFormat("yyyy-MM-dd hh:mm:ss");
//TimeZone gmtTime = TimeZone.getTimeZone("America/Los_Angeles"); 
//format.setTimeZone(gmtTime);

Date one_day_before = new Date(new Date().getTime()-24*60*60*1000);
Date seven_day_before = new Date(new Date().getTime()-7*24*60*60*1000);

//Date ajust_now = new Date(new Date().getTime()+ 12*60*60*1000);  
Date ajust_now = new Date();

//default time_begin is one day before
String time_begin = format.format(one_day_before);
String time_end  =  format.format(ajust_now);

String time_one_day_before  = format.format(one_day_before);
String time_seven_day_before  = format.format(seven_day_before);
String time_now = format.format(ajust_now);

//default durtime is 1day
String durtime = "L1D";
String ifformat = "no";

String need_name_search ="no";
String need_search_domain = "no";
String my_search_user = "Search User Name";
String my_search_domain = "Search Domain";

//=====================for user name  search begin
if(request.getParameter("need_name_search")!=null)
{
	System.out.println("get from request need_name_search is : " + need_name_search);
	need_name_search = request.getParameter("need_name_search");
}
else
{
	System.out.println("no para need_name_search in request");
}

if(request.getParameter("need_search_domain")!=null)
{
	System.out.println("get from request need_search_domain is : "+need_search_domain);
	need_search_domain = request.getParameter("need_search_domain");
}
else
{
	System.out.println("no para need_search_domain in request");
}

if(request.getParameter("my_search_user")!=null)
{
	System.out.println("get from request my_search_user is : "+my_search_user);
	my_search_user = request.getParameter("my_search_user");
}
else
{
	System.out.println("no para my_search_user in request");
}

if(request.getParameter("my_search_domain")!=null)
{
	System.out.println("get from request my_search_domain is : "+my_search_domain);
	my_search_domain = request.getParameter("my_search_domain");
}
else
{
	System.out.println("no para my_search_domain in request");
}
//=====================for user name  search end


if(request.getParameter("offset")!=null)
{
	offset = Integer.parseInt(request.getParameter("offset"));
	System.out.println("offset is : "+offset);
}

if(request.getParameter("durtime")!=null)
{
	System.out.println("get durtime is : "+ durtime);
	durtime = request.getParameter("durtime");
}

if(request.getParameter("ifformat")!=null)
{
	System.out.println("get ifformat is : "+ ifformat);
	ifformat = request.getParameter("ifformat");
}

if(request.getParameter("time_begin")!=null)
{
	System.out.println("get from request time_begin is : "+time_begin);
	time_begin = request.getParameter("time_begin");
}
else
{
	System.out.println("no para time_begin in request");
}

if(request.getParameter("time_end")!=null)
{
	System.out.println("get from request time_end  is : "+time_end);
	time_end = request.getParameter("time_end");
}
else
{
	System.out.println("no para time_end in request");
}

System.out.println("time_one_day_before is : "+time_one_day_before);
System.out.println("time_seven_day_before is : "+time_seven_day_before);
System.out.println("time_begin is : "+time_begin);
System.out.println("time_end  is : "+time_end);
System.out.println("durtime is : "+durtime);
System.out.println("ifformat is : "+ifformat);

if(request.getParameter("removesame")!=null)
{
	removesame = request.getParameter("removesame");
	System.out.println("get para removesame is : " +removesame);
}
else
{
	System.out.println("none para removesame");
}

if(request.getParameter("clientcert_handle")!=null)
{ 
    commonLog = " when Client Certificate is requested";
    if(request.getParameter("clientcert_handle").compareToIgnoreCase("tunnel")==0)
    {
        ini.SetKeyValue(httpsSect, "clientcert_handling", "tunnel");
        logEntry = "Tunnel" + commonLog;
    }
    else
    { 
        if(request.getParameter("clientcert_handle").compareToIgnoreCase("block")==0)     
        {
            ini.SetKeyValue(httpsSect, "clientcert_handling", "block");
            logEntry = "Block" + commonLog;
        }
    }
    try 
    {
        AuditTrailLogger.getInstance().log(request, logEntry );
        System.out.println(logEntry);
    } 
    catch (Exception e)
    {
        System.out.println("ClientCertSetting Error in Audit Log: " + e.getMessage());
    }        
    ini.WriteConfig(location_file_ini);         

    //take daemon action
    int daemon_action = 0;
    if(request.getParameter("daemonaction") != null)
    {
        daemon_action = Integer.parseInt(request.getParameter("daemonaction"));
        IWSSUtil.UI_out_println("daemon action: "+daemon_action);
        if(daemon_action != 0)  
            DaemonAction.TakeAction(daemon_action);
    }
}
%>

<%
   //#########=======failed https access===========################################
	
	String tunnel_configfile = "/etc/iscan/HttpsClientCertTunnelDomains.ini";

	String exceptionstr = IWSSJNI.GetURLBlockList(tunnel_configfile, "block");
	if(exceptionstr.length() < 3) {
		exceptionstr = "";
	}
	exceptionstr = "<URLList>" + exceptionstr + "</URLList>";
	System.out.println("exceptionstr");
	System.out.println(exceptionstr);
	IWSSXML elist = new IWSSXML(exceptionstr);

	String tunnelstr = IWSSJNI.GetURLBlockList(tunnel_configfile, "allow");
	if(tunnelstr.length() < 3) {
		tunnelstr = "";
	}
	tunnelstr = "<URLList>" + tunnelstr + "</URLList>";
	System.out.println("tunnelstr");
	System.out.println(tunnelstr);
	IWSSXML tlist = new IWSSXML(tunnelstr);

	
	ResultSet rsall_item = null;
	int allitems = 0;
		
try {
	System.out.println("when connect to db, get the items number");
	if(removesame.equals("no"))
	{
		if(ifformat.equals("no"))
		{
			if(durtime.equals("L1D"))
			{
				if(need_name_search.equals("yes") && need_search_domain.equals("yes"))
				{
					System.out.println("removesame:no, counts L1D, ifformat: no, search by user+domain");
					rsall_item = JdbcHelper.query("GetCountsLogClientCertificateOnedayuserdomain",my_search_user,my_search_domain);
				}
				
				else if(need_name_search.equals("yes") && need_search_domain.equals("no"))
				{
					System.out.println("removesame:no,counts L1D, ifformat: no, search by user");
					rsall_item = JdbcHelper.query("GetCountsLogClientCertificateOnedayuser",my_search_user);
				}
				
				else if(need_name_search.equals("no") && need_search_domain.equals("yes"))
				{
					System.out.println("removesame:no,counts L1D, ifformat: no, search by domain");
					rsall_item = JdbcHelper.query("GetCountsLogClientCertificateOnedaydomain",my_search_domain);
				}
				else 
				{
					System.out.println("removesame:no,counts L1D, ifformat:no");
					rsall_item = JdbcHelper.query("GetCountsLogClientCertificateOneday");
				}
				
			}
			else if(durtime.equals("L7D"))
			{
				if(need_name_search.equals("yes") && need_search_domain.equals("yes"))
				{
					System.out.println("removesame:no, counts L7D, ifformat: no, search by user+domain");
					rsall_item = JdbcHelper.query("GetCountsLogClientCertificateSevendayuserdomain",my_search_user,my_search_domain);
				}
				
				else if(need_name_search.equals("yes") && need_search_domain.equals("no"))
				{
					System.out.println("removesame:no, counts L7D, ifformat: no, search by user");
					rsall_item = JdbcHelper.query("GetCountsLogClientCertificateSevendayuser",my_search_user);
				}
				
				else if(need_name_search.equals("no") && need_search_domain.equals("yes"))
				{
					System.out.println("removesame:no, counts L7D, ifformat: no, search by domain");
					rsall_item = JdbcHelper.query("GetCountsLogClientCertificateSevendaydomain",my_search_domain);
				}
				else 
				{
					System.out.println("removesame:no,counts L7D, ifformat: no");
					rsall_item = JdbcHelper.query("GetCountsLogClientCertificateSevenday");
				}
			}
		}
		else if(ifformat.equals("yes"))
		{	
			if(need_name_search.equals("yes") && need_search_domain.equals("yes"))
			{
				System.out.println("removesame:no, counts definetime ,ifformat: yes, search by user+domain");
				rsall_item = JdbcHelper.query("GetCountsLogClientCertificateuserdomain",time_begin, time_end, my_search_user, my_search_domain);
			}
				
			else if(need_name_search.equals("yes") && need_search_domain.equals("no"))
			{
				System.out.println("removesame:no ,counts definetime ,ifformat: yes, search by user");
				rsall_item = JdbcHelper.query("GetCountsLogClientCertificateuser",time_begin, time_end, my_search_user);
			}
				
			else if(need_name_search.equals("no") && need_search_domain.equals("yes"))
			{
				System.out.println("removesame:no ,counts definetime,ifformat: yes, search by domain");
				rsall_item = JdbcHelper.query("GetCountsLogClientCertificatedomain",time_begin, time_end, my_search_domain);
			}
			else 
			{
				System.out.println("removesame:no ,counts definetime,ifformat: yes");
				rsall_item = JdbcHelper.query("GetCountsLogClientCertificate", time_begin, time_end);
			}
		}
	}
	
	else if(removesame.equals("yes"))
	{
		if(ifformat.equals("no"))
		{
			if(durtime.equals("L1D"))
			{
				if(need_name_search.equals("yes") && need_search_domain.equals("yes"))
				{
					System.out.println("removesame:yes, counts L1D, ifformat: no, search by user+domain");
					rsall_item = JdbcHelper.query("GetDiffCountsLogClientCertificateOnedayuserdomain", my_search_user, my_search_domain);
				}
					
				else if(need_name_search.equals("yes") && need_search_domain.equals("no"))
				{
					System.out.println("removesame:yes, counts L1D, ifformat: no, search by user");
					rsall_item = JdbcHelper.query("GetDiffCountsLogClientCertificateOnedayuser", my_search_user);
				}
					
				else if(need_name_search.equals("no") && need_search_domain.equals("yes"))
				{
					System.out.println("removesame:yes, counts L1D, ifformat: no, search by domain");
					rsall_item = JdbcHelper.query("GetDiffCountsLogClientCertificateOnedaydomain", my_search_domain);
				}
				else 
				{
					System.out.println("removesame:yes, counts L1D, ifformat: no");
					rsall_item = JdbcHelper.query("GetDiffCountsLogClientCertificateOneday");
				}
			}
			else if(durtime.equals("L7D"))
			{
				if(need_name_search.equals("yes") && need_search_domain.equals("yes"))
				{
					System.out.println("removesame:yes, counts L7D, ifformat: no, search by user+domain");
					rsall_item = JdbcHelper.query("GetDiffCountsLogClientCertificateSevendayuserdomain",my_search_user, my_search_domain);
				}
					
				else if(need_name_search.equals("yes") && need_search_domain.equals("no"))
				{
					System.out.println("removesame:yes, counts L7D, ifformat: no, search by user");
					rsall_item = JdbcHelper.query("GetDiffCountsLogClientCertificateSevendayuser", my_search_user);
				}
					
				else if(need_name_search.equals("no") && need_search_domain.equals("yes"))
				{
					System.out.println("removesame:yes, counts L7D, ifformat: no, search by domain");
					rsall_item = JdbcHelper.query("GetDiffCountsLogClientCertificateSevendaydomain", my_search_domain);
				}
				else 
				{
					System.out.println("removesame:yes, counts L7D, ifformat: no");
					rsall_item = JdbcHelper.query("GetDiffCountsLogClientCertificateSevenday");
				}
			}
		}
		else if(ifformat.equals("yes"))
		{	
				if(need_name_search.equals("yes") && need_search_domain.equals("yes"))
				{
					System.out.println("removesame:yes, counts definetime, ifformat: yes, search by user+domain");
					rsall_item = JdbcHelper.query("GetDiffCountsLogClientCertificateuserdomain",time_begin, time_end,my_search_user, my_search_domain);
				}
					
				else if(need_name_search.equals("yes") && need_search_domain.equals("no"))
				{
					System.out.println("removesame:yes, counts definetime, ifformat: yes, search by user");
					rsall_item = JdbcHelper.query("GetDiffCountsLogClientCertificateuser", time_begin, time_end,my_search_user);
				}
					
				else if(need_name_search.equals("no") && need_search_domain.equals("yes"))
				{
					System.out.println("removesame:yes, counts definetime, ifformat: yes, search by domain");
					rsall_item = JdbcHelper.query("GetDiffCountsLogClientCertificatedomain", time_begin, time_end, my_search_domain);
				}
				else 
				{
					System.out.println("removesame:yes, counts definetime, ifformat: yes");
					rsall_item = JdbcHelper.query("GetDiffCountsLogClientCertificate",time_begin, time_end);
				}
		}
	}

	while (rsall_item.next())
	{
		allitems = Integer.parseInt(rsall_item.getString("count"));
		System.out.println("allitems :"+allitems);
	}
} 
catch (SQLException e) 
{
	out.println(e);
	e.printStackTrace();
 }
finally
{
	JdbcHelper.closeResultSet(rsall_item);
}
%>

<html>
<head>
<META HTTP-EQUIV="content-type" CONTENT="text/html; charset=UTF-8">
<meta http-equiv="X-UA-Compatible" content="IE=EDGE,chrome=1" />
<title>Trend Micro InterScan Web Security Virtual Appliance</title>

<link href="html/trend-style.css" rel="stylesheet" type="text/css">
<SCRIPT language="javascript" src="html/func.js"></SCRIPT>
<SCRIPT language="javascript" src="html/i18n_warnmsg.js"></SCRIPT>

<script language="javascript" src="html/list_checkall.js"></script>
<script language="javascript" src="html/func.js"></script>
<!--<script language="javascript" src="html/mouseover_help.js"></script> -->
<script language="JavaScript" src="html/tooltip.js"                                     type="text/javascript"></script>
<script language="JavaScript" src="html/localization.js"                                type="text/javascript"></script>
<script language="Javascript" src="html/fade_shih.js"                                   type="text/javascript"></script>
<script language="javascript" src="html/error_code.js"                                  type="text/javascript"></script>
<!-- script language="javascript" src="log/js/lib/jquery-1.8.3.min.js"                  type="text/javascript"></script -->
<script language="javascript" src="lib/tmPlugins/jquery-1.8.3.min.js"                   type="text/javascript"></script>
<script language="javascript" src="log/js/lib/jquery-ui-1.10.2.custom.min.js"           type="text/javascript"></script>
<script language="javascript" src="lib/tmPlugins/jquery-ui-timepicker-addon.js"         type="text/javascript"></script>
<script language="javascript" src="lib/tmPlugins/jquery-ui-timepicker-addon-plus.js"    type="text/javascript"></script>

<style type="text/css">
	table.table-tabs td img { display: block; }
</style>

<style type="text/css" title="currentStyle">
		@import "log/themes/jquery-ui-1.10.2/jquery-ui-1.10.2.custom.css";
		@import "lib/tmPlugins/jquery-ui-1.9.2.custom.min.css";
		@import "lib/tmPlugins/jquery-ui-timepicker-addon.css";
</style>

<script language="Javascript" src="log/page/timezone.jsp"								type="text/javascript"></script>
<script language="javascript" src="log/js/date.js"                                      type="text/javascript"></script>
<script type="text/javascript">
	timezoneJS.timezone.zoneFileBasePath = "log/js/tz";
	var zoneFile = ['southamerica', 'northamerica'];
	if(currentTimeZone) {
		var zf = currentTimeZone.split("/");
		zoneFile = zf[0].toLowerCase();
		if(zoneFile == "america") {
			zoneFile = ['southamerica', 'northamerica'];
		}
	}
	timezoneJS.timezone.defaultZoneFile = zoneFile;
	timezoneJS.timezone.init();
</script>

<script language="JavaScript">

function doRemovesame()
{
	//console.log("enter remove same item");
	document.getElementById("removesame").value = "yes";
	document.getElementById("offset").value = 0;
	setTimeout( "document.saveform2.submit()", 100 );
}
function doShowall()
{
	//console.log("enter remove same item");
	document.getElementById("removesame").value = "no";
	document.getElementById("offset").value = 0;
	setTimeout( "document.saveform2.submit()", 100 );
}

function filter_user_domain()
{
	var tip_name = "Search User Name";
	var tip_domain = "Search Domain";
	
	var userName = document.getElementById("mysearch_user").value;
	var domain =   document.getElementById("mysearch_domain").value;
	
	var changeuser=false;
	var changedomain=false;
				
	//console.log("userName:", userName);
	//console.log("domain:", domain);
				
	if(userName == "" || userName == tip_name)
	{
		document.getElementById("need_name_search").value= "no";
		document.getElementById("my_search_user").value= "Search User Name";
	}
	else
	{
		changeuser=true;
		document.getElementById("need_name_search").value= "yes";
		document.getElementById("my_search_user").value= userName;
	}
	
	
	if(domain == "" || domain == tip_domain)
	{
		document.getElementById("need_search_domain").value= "no";
		document.getElementById("my_search_domain").value= "Search Domain";
	}	
	else
	{
		changedomain=true;
		document.getElementById("need_search_domain").value= "yes";
		document.getElementById("my_search_domain").value= domain;
	}
				
	//console.log("update datatable because username domain");
	
	if(changedomain ==true ||changeuser ==true)
	{
		//console.log("change domain or user, index to 0");
		document.getElementById("offset").value = 0;
	}
	setTimeout( "document.saveform2.submit()", 100 );
				
}

function doSubmit()
{  
    if( document.saveform.clientcert_handling[0].checked ) 
    {
        document.getElementById("clientcert_handle").value = "tunnel";
    } 
    else 
    {
        document.getElementById("clientcert_handle").value = "block";
    }

    document.saveform.daemonaction.value = httpreload;
    setTimeout( "document.saveform.submit()", 100 );
}

function EnableSaveButton1()
{
    if(document.saveform.save != null)
    {
        document.saveform.save.disabled=false;
	}
}
</script>

<style type="text/css">
	#dataTable td div{
	text-overflow: ellipsis;
	overflow: hidden;
	white-space: nowrap;
	}

	#dataTable td div:hover{
//	overflow:visible;
	cursor:pointer;
	}

   // .setList {
//	width:517px;
//    }

	.ui-corner-tr {
	border-top-right-radius: 0px;
	}

	.ui-corner-tl {
	border-top-left-radius: 0px;
	}

	.ui-widget {
	font-size: 10px;
	}

	#duration-picker .timeRangeContainer .timeRange {
	border: 1px solid #D0D0D0;
	}

	.ui-state-default, .ui-widget-content .ui-state-default, .ui-widget-header .ui-state-default {
//	background: url("images/ui-bg_glass-75_e6e6e6-1x400.png") repeat-x scroll 50% 50% #E6E6E6;
	border: 1px solid #D3D3D3;
	color: #555555;
	font-weight: normal;
	}

	.ui-datepicker-calendar a:link {
	text-decoration:none;
	color: #555555;

	}

	.ui-widget-header {
//	background:url("images/ui-bg_highlight-soft_75_cccccc_1x100.png") repeat-x scroll 50% 50% #CCCCCC;
	border: 1px solid #AAAAAA;
	color: #222222;
	font-weight: bold;
	}
</style>
</head>

<body onLoad="bgFade();" bgcolor="#FFFFFF" leftmargin="0" topmargin="0" marginwidth="0" marginheight="0">
<form action="httpsdecrypt_client_certificate_handling.jsp"  method="post" name="saveform">
<input type="hidden" name="clientcert_handle"  id="clientcert_handle"  value="no">
<input type="hidden" name="op" value="save">
<input type="hidden" name="daemonaction" value="0">


<!-- bellow is first table for  globol  setting -->
<!-- ###################################################################============================================-->
<table width="700" border="0" cellspacing="0" cellpadding="0">
  <tr> 
    <td width="507">
	  <table width="507" border="0" cellspacing="0" cellpadding="0">
        <tr> 
          <td width="238" class="content-title"><i18n:message bundleRef="bundleHttp" key="https.setting.title" /></td>
          <td width="269" valign="bottom" class="data1">&nbsp; 
            </td>
        </tr>
      </table></td>
    <td width="33" valign="bottom"> 
      <div align="right"><A href="javascript:openhelpwin('https_clientcert.htm');">
      <img src="images/question.gif" width="18" height="18" border="0"></a></div></td>
  </tr>
  <tr>
    <td colspan="2" class="hor-dotted-line"><img src="images/1space_cui.gif" alt="" width="1" height="10"></td>
  </tr>
  <tr>
    <td colspan="2"><img src="images/1space_cui.gif" alt="" width="1" height="10"></td>
  </tr>
</table>
<table width="700" border="0" cellspacing="0" cellpadding="0">
  <tr> 
      <!-- TABS -->
      <td background="images/tab_background_cui.gif">
		<table cellpadding="0" cellspacing="0" border="0">
		<tr>
			<td><img src="images/tab_inactive1_left_cui.gif" width="11" height="23" alt="" border="0"></td>
			<td background="images/tab_inactive_background_cui.gif" class="tabinactive" valign="top" nowrap><A
				onMouseOver="this.style.color='#FF0000';" 
				style="COLOR: #000000; TEXT-DECORATION: none" 
				onmouseout="this.style.color='#000000';" 
				href="httpsdecrypt_server_certificate_validation.jsp" ><i18n:message bundleRef="bundleHttp" key="https.setting.server_certificate" /></a></td>
			<td><img src="images/tab_inactive_right_cui.gif" width="23" height="23" alt="" border="0"></td>
			<td><img src="images/tab_active2_left_cui.gif" width="11" height="23" alt="" border="0"></td>
			<td valign="top" background="images/tab_active_background_cui.gif" class="tabactive" nowrap>
				<i18n:message bundleRef="bundleHttp" key="https.setting.client_certificate" /></td>
			<td><img src="images/tab_active_right_cui.gif" width="23" height="23" alt="" border="0"></td>
			<td><img src="images/tab_inactive2_left_cui.gif" width="11" height="23" alt="" border="0"></td>
			<td valign="top" background="images/tab_inactive_background_cui.gif" class="tabinactive" nowrap><A
				onMouseOver="this.style.color='#FF0000';" 
				style="COLOR: #000000; TEXT-DECORATION: none" 
				onmouseout="this.style.color='#000000';" 
				href="httpsdecrypt_root_ca.jsp"><i18n:message bundleRef="bundleHttp" key="https.setting.server_ctf.root_ctf_authority" /></a></td>
			<td><img src="images/tab_inactive_right_cui.gif" width="23" height="23" alt="" border="0"></td>

 			<td><img src="images/tab_inactive2_left_cui.gif" width="11" height="23" alt="" border="0"></td>
            <td valign="top" background="images/tab_inactive_background_cui.gif" class="tabinactive" nowrap><A
                onMouseOver="this.style.color='#FF0000';"
                style="COLOR: #000000; TEXT-DECORATION: none"
                onmouseout="this.style.color='#000000';"
                href="httpsdecrypt_ssl_method.jsp" ><i18n:message bundleRef="bundleHttp" key="https.setting.ssl_method.title" /></a></td>
            <td><img src="images/tab_inactive_right_cui.gif" width="23" height="23" alt="" border="0"></td>


		</tr>
		</table>
      </td>
      <td background="images/tab_background_cui.gif" align="right">
        <img src="images/tab_right_corner_cui.gif" width="6" height="23" alt="" border="0"></td>
      <!-- /TABS -->
  </tr>
</table>
<TABLE cellSpacing=0 cellPadding=0 width="700" border=0 class="border">
	<TR> 
		<TD style="padding:8px"> 
            <TABLE width="528" border="0" cellspacing="0" cellpadding="0">
              <TR>
                <TD width="528" height="22" class="data1"><B><i18n:message bundleRef="bundleHttp" key="https.setting.client_ctf.action_when_ctf_requested" /></B></TD>
              <TR>
                <TD class="data1"><INPUT onClick="EnableSaveButton1()" type=radio value=tunnel name=clientcert_handling <%if(ini.GetKeyValue(httpsSect, "clientcert_handling").equalsIgnoreCase("tunnel")) {%> checked <%}%>> <i18n:message bundleRef="bundleHttp" key="https.setting.client_ctf.tunnel" /></TD>
			  </TR>
              <TR>
                <TD class="data1"><INPUT onClick="EnableSaveButton1()" type=radio value=block name=clientcert_handling <%if(ini.GetKeyValue(httpsSect, "clientcert_handling").equalsIgnoreCase("block")) {%> checked <%}%>> <i18n:message bundleRef="bundleHttp" key="https.setting.client_ctf.block" /></TD>
			  </TR>
           </TABLE>
		</TD>
	</TR>
	<tr>
		<TD><img src="images/1space_cui.gif" alt="" width="1" height="10"></TD>
	</tr>
</table>
<%
if (access == 3)
{
%>
<table width="700" border="0" cellspacing="0" cellpadding="0">
  <tr> 
    <td height="28" valign="bottom">
        <input name="save" type="button"  class="button" value="<i18n:message bundleRef='bundleCommon' key='button.save' />" onClick="javascript:doSubmit();" disabled>
        <input name="cancel" type="button" class="button" value="<i18n:message bundleRef='bundleCommon' key='button.cancel' />" 
               onclick="javascript:self.location.replace('httpsdecrypt_client_certificate_handling.jsp')">
   </td>
  </tr>
</table>
<%
}
%> 
</form>


<%
if (enable_client_enhance.equals("yes"))
{
%>

<br>
<form action="httpsdecrypt_client_certificate_handling.jsp" method="post" name="saveform2" >
<input type="hidden" name="limit"  id="limit"  value=20>
<input type="hidden" name="offset" id="offset" value=<%=offset%>>
<input type="hidden" name="time_begin" id="time_begin" value="<%=time_begin%>">
<input type="hidden" name="time_end" id="time_end" value="<%=time_end%>">
<input type="hidden" name="durtime" id="durtime" value="<%=durtime%>">
<input type="hidden" name="ifformat" id="ifformat" value="<%=ifformat%>">
<input type="hidden" name="removesame" id="removesame" value="<%=removesame%>">
<input type="hidden" name="my_search_user" id="my_search_user" value="<%=my_search_user%>">
<input type="hidden" name="my_search_domain" id="my_search_domain" value="<%=my_search_domain%>">
<input type="hidden" name="need_name_search" id="need_name_search" value="<%=need_name_search%>">
<input type="hidden" name="need_search_domain" id="need_search_domain" value="<%=need_search_domain%>">
<input type="hidden" name="daemonaction" value="0">
<!-- bellow is second table for failed log display -->
<!-- ###################################################################============================================-->
<table width="980" border="0" cellpadding="0" cellspacing="0">
	<tr>
		<td colspan="2">
			<table width="100%" border="0" cellspacing="0" cellpadding="0">
			<!-- TABS -->
				<tr>
					<td background="images/tab_background_cui.gif">
						<table cellpadding="0" cellspacing="0" border="0" class="table-tabs">
							<tr>
								<td valign="top" background="images/tab_active_background_cui.gif" class="tabactive" nowrap>
									Access History
								</td>
								<td>
									<img src="images/tab_active_right_cui.gif" width="23" height="23" alt="" border="0">
								</td>
							</tr>
						</table>
					</td>
				</tr>
			<!-- TABS -->
				<tr>
					<td class="border">
						<table width="100%" border=0 cellPadding=0 cellSpacing=0 >
							<tr>
								<td>
									<table width="100%" border="0" cellspacing="0" cellpadding="0">
										<tr>
											<td colspan="3"><img src="images/1space_cui.gif" width="1" height="10"></td>
										</tr>
										<tr>
											<td width="100%">
												<table width="100%" height="26" border="0" cellpadding="0" cellspacing="0">
													<tr>
														<td class = 'data1b'>
															<div style="display:inline;padding:0 10 0 5;float:left;">
																<select id="topN_selector" class="button" style="height:24px">
																	<option value="20">20</option>
																</select>
															</div>
															
															<div class="durationContainer selectorContainer" style="display:inline;">
																<div id="duration-picker" style="display:inline"></div>
																<input type="hidden" id="duration" class="duration" value="<%=durtime%>"/>
																<input type="hidden" id="json-report-from" value="0" />
																<input type="hidden" id="json-report-to" value="0" />
															</div>
															
															<div style="display:inline;padding:0 0 0 10;">
																<input type="button" class="button" id="btn_filter"  name="btn_filter" value="Remove duplicate" style="height:24px;width:120px" onClick="javascript:doRemovesame();"></input>
															</div>
															
															<div style="display:inline;padding:0 0 0 5;">
																<input type="button" class="button" id="btn_filter_all" name="btn_filter_all" value="Show all" style="height:24px;width:120px"  onClick="javascript:doShowall();"></input>
																&nbsp;&nbsp;
																<a href="https_clientcertificate_tunneling.jsp" style="COLOR:#FF0000;" >Configure Domain Tunneling </a>
															</div>
														</td>
													</tr>
													<tr>
														<td>
															&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
															<div style="display:inline;padding:0 0 0 10;">
																<input type="text" class="button" id="mysearch_user" name="mysearch_user" style="height:24px"></input>
															</div>
															
															<div style="display:inline;padding:0 0 0 5;">
																<input type="text" class="button" id="mysearch_domain" name="mysearch_domain" style="height:24px;width:250px"></input>
															</div>
															
															<div style="display:inline;padding:0 0 0 5;">
																<input type="button" class="button" id="search_user_domain"  name="search_user_domain" value="Filter Results" style="height:24px;width:120px" onClick="javascript:filter_user_domain();"></input>
															</div>
														</td>
													</tr>	
												</table>
											</td>
											<!--td align="right">&nbsp;</td-->
										</tr>
									</table>
								</td>
							</tr>

							<tr>
								<td colspan="3"><img src="images/1space_cui.gif" width="1" height="10"></td>
							</tr>

							<tr>
								<td>
									<table width="100%" border="0" cellpadding="0" cellspacing="0" class="border2b" id="dataTable" style="table-layout:fixed;">
										<tr>
											<td class="grey" align="center">
												<i18n:message bundleRef="bundleHttp" key="https.tunneling.date" />
											</td>
											<td class="grey" align="center">
												<i18n:message bundleRef="bundleHttp" key="https.tunneling.user_name" />
											</td>
											<td class="grey" align="center">
												<i18n:message bundleRef="bundleHttp" key="https.tunneling.domain_name" />
											</td>
											<td class="grey" align="center">
												Status
											</td>
											<td class="grey-end" align="center" style="width:12%;">
												<i18n:message bundleRef="bundleHttp" key="https.tunneling.action" />
											</td>
										</tr>
										<!-- tr>
											<td align="center" class="data1b">
													2007-11-25
											</td>
											<td class="data1b" align="center">
													Hard-coded
											</td>
											<td class="data1b" align="center">
													no-domain
											</td>
											<td class="data1b" align="center">
													unknown_failure
											</td>
											<td class="data1b" align="center">
													no-action
											</td>
										</tr -->
									</table>
								</td>
							</tr>

							<!--tr>
								<td colspan="3"><img src="images/1space_cui.gif" width="1" height="10"></td>
							</tr-->
							<tr>
								<td width="100%">
									<table width="100%">
										<td width="50%" class="data1" align="right">
											<a href="#" id="btn_prev"><i18n:message bundleRef="bundleHttp" key="https.tunneling.prev" /></a>
										</td>
										<td width="50%" class="data1">
											<a href="#" id="btn_next"><i18n:message bundleRef="bundleHttp" key="https.tunneling.next" /></a>
										</td>
									</table>
								</td>
							</tr>
						</table>
					</td>
				</tr>
               <%if(access == 3){%>
			   <!--
				<tr>
				
					<td class="data1">
						<input type="button" class="button" id="btn_save" name="btn_save" value="<i18n:message bundleRef='bundleHttp' key='https.tunneling.save' />"></input>
						<input type="button" class="button" id="btn_cancel" name="btn_cancel" value="<i18n:message bundleRef='bundleHttp' key='https.tunneling.cancel' />"></input>
						<input type="button" class="button" id="btn_refresh" name="btn_refresh" value="<i18n:message bundleRef='bundleHttp' key='https.tunneling.refresh' />"></input>
					</td>
				</tr>
				-->
				<%}%>
			</table>
		</td>
	</tr>
</table>
</form>

<script language="JavaScript">
$(document).ready(function() 
{
	
	// default tip
	var tip_name = "Search User Name";
	var tip_domain = "Search Domain";
	
	var need_name_search = "<%=need_name_search%>";
	var need_search_domain = "<%=need_search_domain%>";
	var my_search_user = "<%=my_search_user%>";
	var my_search_domain = "<%=my_search_domain%>";
	
// control the paging function
	var can_next = false;
	var can_prev = false;
	var offset = <%=offset%>;
	var all_item = <%=allitems%>;
	
	
	if(offset >= 20)
		can_prev = true;
	
	if(all_item - offset > 20)
		can_next = true;

	//console.log("offset :",offset);
	//console.log("all_item :",all_item);
	//console.log("can_next :",can_next);
	//console.log("can_prev :",can_prev);

// regExp for elist and tlist
	var re_elist = [];
	var re_tlist = [];

	//type, "t" for tunnel, "e" for exception
	function generate_re(item, type) {
		var re_item = item.replace(/\./g, "\\.");
		re_item = re_item.replace(/\*/g, "(.*)");
		re_item = re_item.replace(/\?/g, "(.)");

		if(type == "e") {
			//console.log("put re_item in to block list",re_item);
			re_elist.push(re_item);
		} else {
			//console.log("put re_item in to tunnel list",re_item);
			re_tlist.push(re_item);
		}
	}
	
//construct the exception filter
	var elist = [];
	<%
		String item1 = "";
		for(int i = 0; i < elist.GetLength("URLList"); i++) {
			item1 = elist.GetValueByIndex("URLList", i);
	%>
			elist.push("<%=item1%>");
			generate_re("<%=item1%>", "e");
	<%
		}
	%>

//construct the tunnel filter
	var tlist = [];
	<%
		String item2 = "";
		for(int i = 0; i < tlist.GetLength("URLList"); i++) {
			item2 = tlist.GetValueByIndex("URLList", i);
	%>
			tlist.push("<%=item2%>");
			generate_re("<%=item2%>", "t");
	<%
		}
	%>

	function initPage() 
	{
		if(need_name_search == "no")
		{
			$('input[name=mysearch_user]').val(tip_name);
			$('input[name=mysearch_user]').css("color", "grey");
		}
		else
		{
			$('input[name=mysearch_user]').val(my_search_user);
			
			//filter userdomain , cant not do removedump
			/*
			$("#btn_filter").attr("style", "color:grey; text-decoration:none;");
			$("#btn_filter").attr("disabled",true);
			
			$("#btn_filter_all").attr("style", "color:grey; text-decoration:none;");
			$("#btn_filter_all").attr("disabled",true);
			*/
			
		}
		
		if(need_search_domain == "no")
		{
			$('input[name=mysearch_domain]').val(tip_domain);
			$('input[name=mysearch_domain]').css("color", "grey");
		}
		else
		{
			$('input[name=mysearch_domain]').val(my_search_domain);
			
			/*
			$("#btn_filter").attr("style", "color:grey; text-decoration:none;");
			$("#btn_filter").attr("disabled",true);
			
			$("#btn_filter_all").attr("style", "color:grey; text-decoration:none;");
			$("#btn_filter_all").attr("disabled",true);
			*/
		}
		
		var testdur = "<%=durtime%>";
		var ifformat = "<%=ifformat%>";
		//console.log("durtime is:", testdur);
		//console.log("ifformat is:", ifformat);
		
		if(ifformat == "no") 
		{
			$(".timeRangeLabel").attr("data-val", testdur);
			if (testdur == "L1D")
				$(".timeRangeLabel").text($(".optionList").children().eq(0).text());
			if (testdur == "L7D")
				$(".timeRangeLabel").text($(".optionList").children().eq(1).text());
		}
		
		if(ifformat == "yes") 
		{
			var formattime = "<%=time_begin%>" + " to "+ "<%=time_end%>";
			//$(".timeRangeLabel").attr("data-val", formattime);
			$(".timeRangeLabel").text(formattime);
			//console.log("formattime is :",formattime);
		}
		
		$("#duration").val(testdur);

		//console.log("duration value:",$("#duration").val);
		//$("#btn_save").attr("disabled", true);
	}

	/*
	$("#btn_refresh").click(function(e) {
		window.location.href = "httpsdecrypt_client_certificate_handling.jsp";
	});
     */
	 
	function initDataTable() 
	{
		if("<%=removesame%>" == "yes")
		{
			$("#btn_filter").attr("style", "color:grey; text-decoration:none;");
			$("#btn_filter").attr("disabled",true);
			
			//in remove dup, can not do user domain search
			/*
			$("#search_user_domain").attr("style", "color:grey; text-decoration:none;");
			$("#search_user_domain").attr("disabled",true);
			
			$("#mysearch_user").attr("style", "color:grey; text-decoration:none;");
			$("#mysearch_user").attr("disabled",true);
			
			$("#mysearch_domain").attr("style", "color:grey; text-decoration:none;");
			$("#mysearch_domain").attr("disabled",true);
			*/
			
		}
		else if("<%=removesame%>" == "no")
		{
			$("#btn_filter_all").attr("style", "color:grey; text-decoration:none;");
			$("#btn_filter_all").attr("disabled",true);
		}
		else
		{
			//console.log("removesame is :",<%=removesame%>);
		}
		
		if(!can_prev)
		{
			$("#btn_prev").attr("style", "color:grey; text-decoration:none;");
			$("#btn_prev").attr("disabled",true);
		}
		
		if(!can_next)
		{
			$("#btn_next").attr("style", "color:grey; text-decoration:none;");
			$("#btn_next").attr("disabled",true);
		}
		drawDataTable();
	}


	function initDatePicker(opts, timeRange)
	{
		var customTimePeriod = {};
		customTimePeriod['L1D'] = "<i18n:message bundleRef='bundleHttp' key='https.tunneling.L1D' />";
		customTimePeriod['L7D'] = "<i18n:message bundleRef='bundleHttp' key='https.tunneling.L7D' />";

		 
		$("#duration-picker").empty().enhanced_datetimepicker({
			"useLocalTimeZone": true,
			"show_customized_label": true,
			"customized_time_period": customTimePeriod,
			"customized_value": "0",
			"customized_label": "<i18n:message bundleRef='bundleHttp' key='https.tunneling.customized_time_range' />",
			"range_start_label": "From: ",
			"range_start_format": "mm/dd HH:MM",
			"range_end_format": "mm/dd",
			"range_end_label": "To:",
			"form_period": "#duration",
			"form_from": "#json-report-from",
			"form_to": "#json-report-to"
		});

		$("#duration-picker").enhanced_datetimepicker("set_values", {
			"form_period": "#duration",
			"form_from": "#json-report-from",
			"form_to": "#json-report-to"
		});
	}

	function initTimePlugin()
	{
		initDatePicker();
		$('.durationContainer').data('currentDuration', $('.duration').val());
		$('.durationContainer').click(function(e) {
			var newDur = $('.duration').val();
			var oldDur = $('.durationContainer').data('currentDuration');
			//console.log("enter durationContainer click");
			//console.log("newDur :",newDur);
			//console.log("oldDur :",oldDur);
			
			if(newDur == '0' && oldDur != -1) {
				//console.log("return in initTimePlugin");
				return;
			}
			
			//var format_inplugin = document.getElementById("ifformat").value;
			//console.log("====format_inplugin is:",format_inplugin);
			
			if(oldDur != newDur) 
			{
				$("#duration-picker").enhanced_datetimepicker("set_values", {
					"form_period": "#duration",
					"form_from": "#json-report-from",
                    "form_to": "#json-report-to"
				});
				//console.log("oldDur != newDur, newDur :",newDur);
				//console.log("oldDur != newDur, oldDur :",oldDur);
				if(newDur == "L1D")
				{
					document.getElementById("time_begin").value ="<%=time_one_day_before%>";
					document.getElementById("time_end").value ="<%=time_now%>";
					document.getElementById("durtime").value ="L1D";
					document.getElementById("ifformat").value ="no";
					//console.log("updatetable time_begin",document.getElementById("time_begin").value);
					//console.log("updatetable time_end",document.getElementById("time_end").value);
				}
				if(newDur == "L7D")
				{
					document.getElementById("time_begin").value ="<%=time_seven_day_before%>";
					document.getElementById("time_end").value ="<%=time_now%>";
					document.getElementById("durtime").value ="L7D";
					document.getElementById("ifformat").value ="no";
					//console.log("updatetable time_begin",document.getElementById("time_begin").value);
					//console.log("updatetable time_end",document.getElementById("time_end").value);
				}
				document.getElementById("offset").value = 0;
				//console.log("set offset= 0, and will updatetable");
				
				updateDataTable(0);

				//console.log("durationContainer set data: currentDuration, new Dur");
				$('.durationContainer').data('currentDuration', newDur);
			}
		});

		$('.datePickerAction').click(function(e) 
		{
			//console.log("enter datePickerAction.click");
			$('.durationContainer').data('currentDuration', -1);
			format_timerange();
			$('.durationContainer').click();
			
		});
	}

	function format_timerange() 
	{
		if($('.duration').val() == "0") {
		var html = "";
		var ts = new Date(parseInt($.trim($("#json-report-from").val())) * 1000);
		var te = new Date(parseInt($.trim($("#json-report-to").val())) * 1000);

		var ts_month = ts.getMonth() + 1;
		if(ts_month < 10) {
			ts_month = "0" + ts_month;
		}

		var ts_hour = ts.getHours();
		if(ts_hour < 10) {
			ts_hour = "0" + ts_hour;
		}

		var ts_date = ts.getDate();
		if(ts_date < 10) {
			ts_date = "0" + ts_date;
		}

		var ts_minute = ts.getMinutes();
		if(ts_minute < 10) {
			ts_minute = "0" + ts_minute;
		}

		var te_month = te.getMonth() + 1;
		if(te_month < 10) {
			te_month = "0" + te_month;
		}

		var te_date = te.getDate();
		if(te_date < 10) {
			te_date = "0" + te_date;
		}

		var te_hour = te.getHours();
		if(te_hour < 10) {
			te_hour = "0" + te_hour;
		}

		var te_minute = te.getMinutes();
		if(te_minute < 10) {
			te_minute = "0" + te_minute;
		}

		html += ts.getFullYear() + "-" + ts_month + "-" + ts_date + " " + ts_hour + ":" + ts_minute;
		html += " to ";
		html += te.getFullYear() + "-" + te_month + "-" + te_date + " " + te_hour + ":" + te_minute;
		
		document.getElementById("time_begin").value = ts.getFullYear() + "-" + ts_month + "-" + ts_date + " " + ts_hour + ":" + ts_minute;
		document.getElementById("time_end").value   = te.getFullYear() + "-" + te_month + "-" + te_date + " " + te_hour + ":" + te_minute;
		document.getElementById("ifformat").value ="yes";
		
		$(".timeRangeLabel").text(html);
	}
	}


	/**/
//num: 0,first page;1,prev;2,next
	function updateDataTable(num)
	{
		switch(num) {
			case 0:
				setTimeout( "document.saveform2.submit()", 100 );
				break;
			case 1:
				console.log("go pre");
				var indent = document.getElementById("offset").value % 20;
				if( indent == 0)
					indent = 40;
				else
					indent = 20 + indent;
				
				//console.log("indent :",indent);
				for(var i = 1 ; i<= indent; i++)
				{
					document.getElementById("offset").value--;
				}
				//console.log("go pre, document.getElementById :",document.getElementById("offset").value);
				setTimeout("document.saveform2.submit()", 100 );
				break;
			case 2:
				console.log("go next");
				setTimeout( "document.saveform2.submit()", 100 );
				break;
		}
	};
	
//type:0 all , type 1: remove duplicate
	function drawDataTable()
	{
		$(".dy_tr").remove();
		var date = "";
		var html = "";
		var failureReason = "";
		var key = "";
		var action_type = "";
		var user = "";
		var domain = "";
		var failureReason = "";
<%
int countrows1 = 0;
ResultSet rsall = null;
try {
		System.out.println("when connect to db ,offset is:" + offset);
		System.out.println("when connect to db ,timebegin is:" + time_begin);
		System.out.println("when connect to db ,timeend is:" + time_end);
		System.out.println("when connect to db ,durtime is: " + durtime);
		System.out.println("when connect to db ,removesame is: " + removesame);
		System.out.println("when connect to db ,need_name_search is: " + need_name_search);
		System.out.println("when connect to db ,need_search_domain is: " + need_search_domain);
		System.out.println("when connect to db ,my_search_user is: " + my_search_user);
		System.out.println("when connect to db ,my_search_domain is: " + my_search_domain);
		
		if(removesame.equals("no"))
		{
			if(ifformat.equals("yes"))
			{
				if(need_name_search.equals("yes") && need_search_domain.equals("yes"))
				{
					System.out.println("removesane: no, ifformat: yes, serach user+domain");
					//================================================AAAAAAAAAAAAAAAAAA=======================
					rsall = JdbcHelper.query("GetLogClientCertificateuserdomain", time_begin,time_end,my_search_user,my_search_domain,offset);
				}
				else if(need_name_search.equals("yes") && need_search_domain.equals("no"))
				{
					System.out.println("removesane: no, ifformat: yes, serach user");
					rsall = JdbcHelper.query("GetLogClientCertificateuser", time_begin,time_end,offset,my_search_user);
				}
				else if(need_name_search.equals("no") && need_search_domain.equals("yes"))
				{
					System.out.println("removesane: no, ifformat: yes, serach domain");
					rsall = JdbcHelper.query("GetLogClientCertificatedomain", time_begin,time_end,offset,my_search_domain);
				}
				else
				{
					System.out.println("removesane: no, ifformat: yes, serach domain");
					rsall = JdbcHelper.query("GetLogClientCertificate", time_begin,time_end,offset);
				}
			}
			else if(ifformat.equals("no"))
			{
				if(durtime.equals("L1D"))
				{
					if(need_name_search.equals("yes") && need_search_domain.equals("yes"))
					{
						System.out.println("removesane: no, ifformat: no, L1D, serach user+ domain");
						rsall = JdbcHelper.query("GetLogClientCertificateOnedayuserdomain",offset,my_search_user,my_search_domain);
						
					}
					else if(need_name_search.equals("yes") && need_search_domain.equals("no"))
					{
						System.out.println("removesane: no, ifformat: no, L1D, serach user");
						rsall = JdbcHelper.query("GetLogClientCertificateOnedayuser",offset,my_search_user);
						
					}
					else if(need_name_search.equals("no") && need_search_domain.equals("yes"))
					{
						System.out.println("removesane: no, ifformat: no, L1D, serach domain");
						rsall = JdbcHelper.query("GetLogClientCertificateOnedaydomain",offset,my_search_domain);
						
					}
					else
					{
						System.out.println("removesane: no, ifformat: no, L1D");
						rsall = JdbcHelper.query("GetLogClientCertificateOneday",offset);
					}
				}
				
				if(durtime.equals("L7D"))
				{
					if(need_name_search.equals("yes") && need_search_domain.equals("yes"))
					{
						System.out.println("removesane: no, ifformat: no, L7D, serach user+ domain");
						rsall = JdbcHelper.query("GetLogClientCertificateSevendayuserdomain",offset,my_search_user,my_search_domain);
						
					}
					else if(need_name_search.equals("yes") && need_search_domain.equals("no"))
					{
						System.out.println("removesane: no, ifformat: no, L7D, serach user");
						rsall = JdbcHelper.query("GetLogClientCertificateSevendayuser",offset,my_search_user);
						
					}
					else if(need_name_search.equals("no") && need_search_domain.equals("yes"))
					{
						System.out.println("removesane: no, ifformat: no, L7D, serach domain");
						rsall = JdbcHelper.query("GetLogClientCertificateSevendaydomain",offset,my_search_domain);
					}
					else
					{
						System.out.println("removesane: no, ifformat: no, L7D");
						rsall = JdbcHelper.query("GetLogClientCertificateSevenday",offset);
					}
				}
			}
		}
		else if(removesame.equals("yes"))
		{
			if(ifformat.equals("yes"))
			{
				if(need_name_search.equals("yes") && need_search_domain.equals("yes"))
				{
					System.out.println("removesane: yes, ifformat: yes, serach user+ domain");
					//====================================================AAAAAAAAAAAAAAA==================================
					rsall = JdbcHelper.query("GetDiffLogClientCertificateuserdomain",time_begin,time_end, my_search_user,my_search_domain,offset);	
				}
				else if(need_name_search.equals("yes") && need_search_domain.equals("no"))
				{
					System.out.println("removesane: yes, ifformat: yes, serach user");
					rsall = JdbcHelper.query("GetDiffLogClientCertificateuser",time_begin,time_end, offset, my_search_user);		
				}
				else if(need_name_search.equals("no") && need_search_domain.equals("yes"))
				{
					System.out.println("removesane: yes, ifformat: yes, serach domain");
					rsall = JdbcHelper.query("GetDiffLogClientCertificatedomain",time_begin,time_end, offset,my_search_domain);
				}
				else
				{
					System.out.println("removesane: yes, ifformat: yes");
					rsall = JdbcHelper.query("GetDiffLogClientCertificate", time_begin,time_end,offset);
				}
			}
			else if(ifformat.equals("no"))
			{
				if(durtime.equals("L1D"))
				{
					if(need_name_search.equals("yes") && need_search_domain.equals("yes"))
					{
						System.out.println("removesane: yes, ifformat: no, L1D  serach user+ domain");
						rsall = JdbcHelper.query("GetDiffLogClientCertificateOnedayuserdomain",offset, my_search_user,my_search_domain);	
					}
					else if(need_name_search.equals("yes") && need_search_domain.equals("no"))
					{
						System.out.println("removesane: yes, ifformat: no, L1D  serach user");
						rsall = JdbcHelper.query("GetDiffLogClientCertificateOnedayuser",offset, my_search_user);	
					}
					else if(need_name_search.equals("no") && need_search_domain.equals("yes"))
					{
						System.out.println("removesane: yes, ifformat: no, L1D serach domain");
						rsall = JdbcHelper.query("GetDiffLogClientCertificateOnedaydomain",offset,my_search_domain);
					}
					else
					{
						System.out.println("removesane: yes, ifformat: no, L1D");
						rsall = JdbcHelper.query("GetDiffLogClientCertificateOneday", offset);
					}
				}
				
				if(durtime.equals("L7D"))
				{
					if(need_name_search.equals("yes") && need_search_domain.equals("yes"))
					{
						System.out.println("removesane: yes, ifformat: no, L7D  serach user+ domain");
						rsall = JdbcHelper.query("GetDiffLogClientCertificateSevendayuserdomain",offset, my_search_user,my_search_domain);	
					}
					else if(need_name_search.equals("yes") && need_search_domain.equals("no"))
					{
						System.out.println("removesane: yes, ifformat: no, L1D  serach user");
						rsall = JdbcHelper.query("GetDiffLogClientCertificateSevendayuser",offset, my_search_user);	
					}
					else if(need_name_search.equals("no") && need_search_domain.equals("yes"))
					{
						System.out.println("removesane: yes, ifformat: no, L1D serach domain");
						rsall = JdbcHelper.query("GetDiffLogClientCertificateSevendaydomain",offset,my_search_domain);
					}
					else
					{
						System.out.println("removesane: yes, ifformat: no, L1D");
						rsall = JdbcHelper.query("GetDiffLogClientCertificateSevenday", offset);
					}
				}
			}
		}

	while (rsall.next())
	{
		String username = rsall.getString("username");
		String domain = rsall.getString("domain");
		Timestamp time = rsall.getTimestamp("timestamp");
		long Ltime = time.getTime();
		System.out.println("Ltime :" +Ltime);
		countrows1++;
		System.out.println(domain);
%>
		var i = <%=countrows1%>;

		username = "<%=username%>";
		domain = "<%=domain%>";

		failureReason = "Client certificate required";
		html += '<tr class="dy_tr">';
		date = new Date(<%=Ltime%>);
		//console.log("Date is :",date);
		html +=     '<td align="center" class="data' + ((i%2) + 1) + 'b">';
		html +=	    '<div title="' + date.toLocaleString() + '">';
		html +=         	date.toLocaleString();
		html +=	    '</div>';
		html +=     '</td>';
		html +=     '<td align="center" class="data' + ((i%2) + 1) + 'b">';
		html +=	    '<div title="<%=username%>">';
		html +=         	"<%=username%>";
		html +=	    '</div>';
		html +=     '</td>';
		html +=     '<td align="center" class="data' + ((i%2) + 1) + 'b">';
		html +=	    '<div title="<%=domain%>">';
		html +=         	"<%=domain%>";
		html +=	    '</div>';
		html +=     '</td>';
		html +=     '<td align="center" class="data' + ((i%2) + 1) + 'b">';
		html +=	    '<div title="' + 'Status' +'">';
		html += 	 failureReason;
		'</div>';
		html +      '</td>';
		html +=     '<td align="center" class="data' + ((i%2) + 1) + 'b tunnel_action">';
		action_type = do_action_check("<%=domain%>");
		//console.log("action type return:",action_type);
		if(action_type == 1) { //in block list
			//html +=     "<i18n:message bundleRef='bundleHttp' key='https.tunneling.untunneled' />";
			html +=     '<input type="button" class="button" name="tunnel_button" value="' + "Tunnel"  + '"<%if(access != 3) {%>disabled<%}%>></input>';
			html +=     '<input type="button" class="button" name="block_button" disabled="true" value="' + "Block" + '"<%if(access != 3) {%>disabled<%}%>></input>';
		} else if(action_type == 2){ //in tunnel list
			//console.log("in tunnel list, disable tunnel button");
			html +=     '<input type="button" class="button" name="tunnel_button" disabled="true" value="' + "Tunnel"  + '"<%if(access != 3) {%>disabled<%}%>></input>';
			html +=     '<input type="button" class="button" name="block_button" value="' + "Block" + '"<%if(access != 3) {%>disabled<%}%>></input>';
		} else {
			html +=     '<input type="button" class="button" name="tunnel_button" value="' + "Tunnel" + '"<%if(access != 3) {%>disabled<%}%>></input>';
			html +=     '<input type="button" class="button" name="block_button" value="' + "Block"  + '"<%if(access != 3) {%>disabled<%}%>></input>';
		}
		html += '</td>';
		html += '</tr>'
		document.getElementById("offset").value++;
		//console.log("document offset :",document.getElementById("offset").value);
<%
	}
} 
catch (SQLException e) 
{
	out.println(e);
	e.printStackTrace();
 }
finally
{
	JdbcHelper.closeResultSet(rsall);
}
%>
		$('#dataTable').append(html);
		
		if(!can_next)
		{
			$('#btn_next').attr("style", "color:grey;text-decoration:none");
		} 
		else 
		{
			$('#btn_next').removeAttr("style");
		}
		$("input[name=tunnel_button]").each(function() {
			$(this).unbind("click").click(function() {
				$("input[name=tunnel_button]").attr("style", "color:grey;text-decoration:none");
				$("input[name=tunnel_button]").attr("disabled",true);
				$("input[name=block_button]").attr("style", "color:grey;text-decoration:none");
				$("input[name=block_button]").attr("disabled",true);
				
				var domain = $(this).parent().prev().prev().text().toLowerCase();
				
				var allowlist = "";
				var blocklist = "";
				var allowrmlist = "";
				var data_for_send = "";
				
				var domain_type = do_action_check(domain);
				if(domain_type == 2) //ERROR already in tunnel list
					//console.log("ERROR, domain is in tunnel, can not tunnel :",domain);
				{
					
				}
				else if(domain_type == 1) //in block list, turn block to tunnel
				{
					//console.log("Block to tunnel,domain is :",domain);
					tlist.push(domain);
					for(var i = 0; i < tlist.length; i++) {
						allowlist = allowlist + "&allowlist=" + tlist[i];
					}
					for(var j = 0; j < elist.length; j++) {
						if(elist[j] !=  domain)
							blocklist = blocklist + "&blocklist=" + elist[j];
						else{
							//console.log("delete from block list,domain is:",domain);
						}
					}
					data_for_send = "op=" + "httpsclient_singal_oper" + "&daemonaction=" + "2" + allowlist + blocklist;
					//console.log("data_for_send : ",data_for_send);
				}
				else if(domain_type == 0)
				{
					//console.log("new add a tunnel item:",domain);
					tlist.push(domain);
					for(var i = 0; i < tlist.length; i++) {
						allowlist = allowlist + "&allowlist=" + tlist[i];
					}
					
					for(var j = 0; j < elist.length; j++) {
						blocklist = blocklist + "&blocklist=" + elist[j];
					}
					data_for_send = "op=" + "httpsclient_singal_oper" + "&daemonaction=" + "2" + allowlist + blocklist;
					//console.log("data_for_send:",data_for_send);
				}
				
				$.ajax({
					url: "servlet/com.trend.iwss.gui.servlet.urllistset",
					type: "POST",
					async: false,
					data:  data_for_send,
					success: function(data) {
							//window.location.href = "httpsdecrypt_client_certificate_handling.jsp";
							document.getElementById("offset").value = 0;
							setTimeout( "document.saveform2.submit()", 100 );
					},
					error: function(err) {
						//console.log(err);
					}
				});
			});
		});
		
		$("input[name=block_button]").each(function() {
			$(this).unbind("click").click(function() {
				$("input[name=tunnel_button]").attr("style", "color:grey;text-decoration:none");
				$("input[name=tunnel_button]").attr("disabled",true);
				$("input[name=block_button]").attr("style", "color:grey;text-decoration:none");
				$("input[name=block_button]").attr("disabled",true);
				var domain = $(this).parent().prev().prev().text().toLowerCase();
				
				var allowlist = "";
				var blocklist = "";
				var allowrmlist = "";
				var data_for_send = "";
				
				var domain_type = do_action_check(domain);
				if(domain_type == 1) //ERROR already in block list
				{
					//console.log("ERROR, domain is in block, can not block :",domain);
				}
				else if(domain_type == 2) //in tunnel list, turn tunnel to block, need add allowrm
				{
					//console.log("tunnel to block,domain is:",domain);
					elist.push(domain);
					for(var j = 0; j < elist.length; j++) {
							blocklist = blocklist + "&blocklist=" + elist[j];
					}
					for(var i = 0; i < tlist.length; i++) {
						if(tlist[i]!=  domain) 
							allowlist = allowlist + "&allowlist=" + tlist[i];
						else
						{
							//console.log("delete from tunnel list,domain is:",domain);
						}
					}
					
					data_for_send = "op=" + "httpsclient_singal_oper" + "&daemonaction=" + "2" + "&allowrm="+ domain + allowlist + blocklist;
					//console.log("data_for_send:",data_for_send);
				}
				else if(domain_type == 0)
				{
					//console.log("new add a block item:",domain);
					elist.push(domain);
					for(var j = 0; j < elist.length; j++) {
						blocklist = blocklist + "&blocklist=" + elist[j];
					}
					for(var i = 0; i < tlist.length; i++) {
						allowlist = allowlist + "&allowlist=" + tlist[i];
					}
					data_for_send = "op=" + "httpsclient_singal_oper" + "&daemonaction=" + "2" + allowlist + blocklist;
					//console.log("data_for_send:",data_for_send);
				}
					
				$.ajax({
					url: "servlet/com.trend.iwss.gui.servlet.urllistset",
					type: "POST",
					async: false,
					data: data_for_send ,
					success: function(data) {
						document.getElementById("offset").value = 0;
						setTimeout( "document.saveform2.submit()", 100 );
						//window.location.href = "httpsdecrypt_client_certificate_handling.jsp";
					},
					error: function(err) {
						//console.log(err);
					}
				}); 
			});
		});
}

	function do_action_check(domain) 
	{
		//console.log("enter do_action_check domain",domain);
		domain = domain.toLowerCase();
		
		var i;
		var res = 0;
		var is_continue = true;
		var result;
		for(var i = 0; i < re_elist.length; i++) {
			var pattern = new RegExp(re_elist[i], "g");
			if((result = pattern.exec(domain)) != null) {
				if(result.index == 0 && pattern.lastIndex == domain.length) {
					res = 1; //in block list
					is_continue = false;
					break;
				}
			}
		}

		if(is_continue) {
			for(var i = 0; i < re_tlist.length; i++) {
				var pattern = new RegExp(re_tlist[i], "g");
				if((result = pattern.exec(domain)) != null) {
					if(result.index == 0 && pattern.lastIndex == domain.length) {
						res = 2; //in tunnel list
							break;
					}
				}
			}
		}
		//console.log("do_action_check domain,return ",res);
		return res;
	}

	$('#btn_prev').click(function()
	{
		if(can_prev) {
			console.log("client prev");
		   updateDataTable(1);
		} else {
			return;
		}
	});

	$('#btn_next').click(function() 
	{
		if(can_next) {
			console.log("client prev");
			updateDataTable(2);
		} else {
			return;
		}
	});

	initTimePlugin();
	initDataTable();
	initPage();
});

</script>

<%
}
%>
</body>
</html>
