var po_first = true;
var current_index = -100;
var oldversion;
var previous_expand_index = -100;

function dirty() {
	if (current_index != -100 && oldversion != newversion())
		return true;
	return false;
}

function newversion() {
	var form;
	var answer;
	if (current_index == -1) {
		form = $("document.Saveform");

		form.find("input").each(
				function() {
					if (this.name == "ttl_type" || this.name == "expire_time" || inp.name == "auth_method"
							|| inp.name == "captive_portal")
						return;
					answer += Trim(this.value);
				});
		answer += "mode:";
		if (form.find("input[name='mode']").size() != 0) {
			answer += form.find("input[name='mode']").get(0).checked;
			answer += form.find("input[name='mode']").get(1).checked;
		}
		answer += form.find("input[name='enable']").get().checked;
		answer += "relation:";
		if (form.find("input[name='relationship']").size() != 0) {
			answer += form.find("input[name='relationship']").get(0).checked;
		}
	}
	else {
		form = document.getElementById("saveform" + current_index);
		var inputs = form.getElementsByTagName("input");
		for (var i = 0; i < inputs.length; i++) {
			var inp = inputs[i];
			if (inp.name == "ttl_type" || inp.name == "expire_time" || inp.name == "auth_method"
					|| inp.name == "captive_portal")
				continue;
			answer += Trim(inp.value);
		}

		answer += "mode:";
		if (form.mode.size != 0) {
			answer += form.mode[0].checked;
			answer += form.mode[1].checked;
		}
		answer += form.enable.checked;
		answer += "relation:";
		if (form.relationship.size != 0) {
			answer += form.relationship[0].checked;
		}
	}
	return answer;
}

function hide(line) {
	var tr1 = document.getElementById("tr" + line);
	tr1.style.display = "none";
}

function show(line) {
	var tr1 = document.getElementById("tr" + line);
	tr1.style.display = "";
}

$(document).ready(function() {
	$.ajaxSetup({
		type : "POST",
		dataType : 'xml'
	});
	$('#serverType').change(function() {
		var button = $(document.Saveform.autodetect);
		var val = $(this).val();
		if (val != "0") {
			button.attr('disabled', true);
		}
		else {
			button.removeAttr('disabled');
		}

		if (val == "0") {
			$("#mode").hide();
			var tr1 = document.getElementById("tr1");
			tr1.style.display = "none";

			tr1 = document.getElementById("tr2");
			tr1.style.display = "none";

			tr1 = document.getElementById("tr3");
			tr1.style.display = "";

			tr1 = document.getElementById("tr4");
			tr1.style.display = "";

			tr1 = document.getElementById("tr_ldaps");
			tr1.style.display = "";

			enableKerberos($("document.Saveform"));
		}
		else if (val == "1" || val == "3") {
			$("#mode").css("display", "inline");
			var tr1 = document.getElementById("tr1");
			tr1.style.display = "";

			tr1 = document.getElementById("tr2");
			tr1.style.display = "";

			tr1 = document.getElementById("tr3");
			tr1.style.display = "";

			tr1 = document.getElementById("tr4");
			tr1.style.display = "";

			tr1 = document.getElementById("tr_ldaps");
			tr1.style.display = "none";

			disableKerberos($("document.Saveform"));
			document.Saveform.mode[0].checked = true;
		}
		else {
			$("#mode").css("display", "inline");
			var tr1 = document.getElementById("tr1");
			tr1.style.display = "";

			tr1 = document.getElementById("tr2");
			tr1.style.display = "";

			tr1 = document.getElementById("tr3");
			tr1.style.display = "none";

			tr1 = document.getElementById("tr4");
			tr1.style.display = "none";

			tr1 = document.getElementById("tr_ldaps");
			tr1.style.display = "none";

			document.Saveform.mode[0].checked = true;
		}
	});

	$("input[name='enable']").change(function() {
		var val = this.checked;
		var parent = $(this).parent().parent().parent().parent().parent();
		if (val == true) {
			parent.find("input[name='relationship']").removeAttr('disabled');
			parent.find("input[name='ip']").removeAttr('disabled');
			parent.find("input[name='port']").removeAttr('disabled');
		}
		else {
			parent.find("input[name='relationship']").attr('disabled', true);
			parent.find("input[name='ip']").attr('disabled', true);
			parent.find("input[name='port']").attr('disabled', true);
		}
	});
});

function doFresh() {
	ifEncry = true;
	$.ajax({
		url : "rest/wmi_domain_controllers",
		async : false,
		data : {
			domain : Trim(document.Saveform.domainName.value),
			username : Trim(document.Saveform.server.value),
			password : Trim(document.Saveform.pw.value),
			finddc : false,
			encry : ifEncry,
			isBasic : true
		},
		complete : function(jqXHR, textStatus) {
			if (jqXHR.status != "200") {
				alert(i18n_ldap_message16);
			}
			else {
				var list = $(jqXHR.responseXML).find("controller");
				var tmp = $(list.get(0)).find("hostname").text();
				var parts = tmp.split(":");

				document.Saveform.ip[0].value = parts[0];
				document.Saveform.port[0].value = parts[1];

				var mode = document.Saveform.mode[2];
				mode.checked = true;

				$(mode).parent().parent().parent().parent().find('.kerberosOptions').find('*').removeAttr('disabled')
						.fadeTo(1, 1);

				document.Saveform.domain.value = Trim(document.Saveform.domainName.value.toUpperCase());
				document.Saveform.realm.value = Trim(document.Saveform.domainName.value.toUpperCase());

				var components = Trim(document.Saveform.domainName.value).split(".");
				var bdn = "";
				for (var t = 0; t < components.length; t++) {
					bdn += "DC=";
					bdn += (components[t]);
					if (t != (components.length - 1))
						bdn += ",";
				}

				document.Saveform.name.value = bdn;
				document.Saveform.adminServer.value = parts[0];
				document.Saveform.portNumber.value = 88;

				var ldaps_mode = $(list.get(0)).find("ldaps_mode").text();

				var s = document.Saveform.ldaps_mode;
				if (s != null) {
					s.options[parseInt(ldaps_mode)].selected = true;
				}
			}
		}
	});
}

function checkHostName(str) {
	if (0 == str.length)
		return true;
	if (ValidateIP(str) || ValidateIPv6(str))
		return true;

	var filter = /\.\.|^\.|\.$|^\d+\.\d+\.\d+\.\d+$/;
	if (!filter.test(str)) {
		return true;
	}
	return false;
}

function popularize() {
	var name = Trim(document.Saveform.domainName.value);

	if (po_first && name != "") {
		name = name.replace(/\s/g, "");
		var tmp = "";
		tmp = name.toUpperCase();
		document.Saveform.realm.value = document.Saveform.domain.value = tmp;

		var components = name.split(".");
		var bdn = "";
		for (var t = 0; t < components.length; t++) {
			bdn += "DC=";
			bdn += (components[t]);
			if (t != (components.length - 1))
				bdn += ",";
		}
		document.Saveform.name.value = bdn;

		document.Saveform.adminServer.value = document.Saveform.ip[0].value;
		document.Saveform.portNumber.value = 88;
		EnableSaveButton();
	}

	po_first = false;
}

function enableSub(index) {
	$("input[name='button1111']").removeAttr('disabled');
}

function testConnection(ifalert) {
	var answer = false;
	ifEncry = isEmpty(document.saveform.encryPassword)
			|| Trim(document.saveform.encryPassword.value) != Trim(document.saveform.password.value);

	var components = Trim(document.saveform.domainName.value).split(".");
	var bdn = "";
	for (var t = 0; t < components.length; t++) {
		bdn += "DC=";
		bdn += (components[t]);
		if (t != (components.length - 1))
			bdn += ",";
	}

	$.ajax({
		url : "rest/testConfiguration",
		type : "POST",
		async : false,
		data : {
			vendor : "msldap",
			basedn : bdn,
			user : Trim(document.saveform.serviceAccount.value),
			password : Trim(document.saveform.password.value),
			authmethod : "kerberos"
		},
		complete : function(jqXHR, textStatus) {
			if ((status = jqXHR.status) != "200") {
				if (jqXHR.responseText == "fail to detect LDAP servers") {
					alert(i18n_ldap_msg17 + i18n_ldap_msg20 + i18n_ldap_msg18);
				}
				else {
					alert(i18n_ldap_msg17 + jqXHR.responseText + i18n_ldap_msg18);
				}
				answer = false;
			}
			else {
				if (ifalert == true)
					alert(i18n_ldap_hit1);
				answer = true;
			}
		}
	});
	return answer;
}

function checkIP(element, element2) {
	if (!isEmpty(element)) {
		if (!testIPRange(element)) {
			return false;
		}
		else {
			return true;
		}
	}
	else {
		alert(i18n_valid_ip_range);
		return false;
	}
}

function delDomain(index) {
	var saveform = document.getElementById("saveform" + index);
	saveform.op.value = "delDomain";
	saveform.domainID.value = index;
	setTimeout("sub(" + index + ")", 100);
}

function checkuserid(userid) {
	if(userid.length <=0)
		return false;

	var index = userid.indexOf('@');
	if (index > 0 && index < userid.length)
	{
		return true;
	}

	index = userid.toLowerCase().indexOf("dc=");
	if(index > 0 && index < userid.length)
	{
		return true;
	}

	index = userid.toLowerCase().indexOf("o=");
	if(index > 0 && index < userid.length)
	{
		return true;
	}

	return false;
}

var is_saving = false;

function checkSaveStatus(){
	if (is_saving) {
		return false;
	}

	is_saving = true;
	return true;
}

function Save() {
	if ($('input[name="authType"]:checked').val() == "basic") {
		document.saveform.encry.value = isEmpty(document.saveform.encryPassword)
				|| Trim(document.saveform.encryPassword.value) != Trim(document.saveform.password.value);

		if (isEmpty(document.saveform.domainName)) {
			alert(i18n_ldap_msg6);
			document.saveform.domainName.focus();
			return;
		}
		if (isEmpty(document.saveform.serviceAccount)) {
			alert(i18n_ldap_msg2);
			document.saveform.serviceAccount.focus();
			return;
		}

		if (!checkuserid(document.saveform.serviceAccount.value)) {
			alert(i18n_ldap_msg10);
			document.saveform.serviceAccount.focus();
			return;
		}

		if (isEmpty(document.saveform.password)) {
			alert(i18n_enter_user_password);
			document.saveform.password.focus();
			return;
		}

		var var_expire_time = "120";
		var var_expire_type = "1";

		if (document.getElementsByName("cache")[0].checked) {
			var_expire_time = document.getElementById("ttl1").value;
			var_expire_type = "0";
		}
		else {
			var_expire_time = document.getElementById("ttl2").value;
			var_expire_type = "1";

		}
		document.saveform.expire_time.value = var_expire_time;
		document.saveform.ttl_type.value = var_expire_type;

		var var_auth_method;
		var var_guest_enable;
		var var_cookie_enable;
		var var_captive_portal = document.getElementById("customizedHTML").value;

		if (document.getElementsByName("authentication_method")[0].checked) {
			var_auth_method = "0";
		}
		else
			var_auth_method = "1";

		if (document.getElementById("enableguest").checked) {
			var_guest_enable = "true";
		}
		else
			var_guest_enable = "false";

		if (document.getElementById("enablecookie").checked) {
			var_cookie_enable = "true";
		}
		else {
			var_cookie_enable = "false";
		}

		document.saveform.auth_method.value = var_auth_method;
		document.saveform.captive_portal.value = var_captive_portal;
		document.saveform.guest_enable.value = var_guest_enable;
		document.saveform.cookie_enable.value = var_cookie_enable;

		var tmp = testConnection(false);
		if (!tmp)
			return;

		if (!checkSaveStatus()) {
			return;
		}

		setTimeout("document.saveform.submit()", 100);
	}
	else if ($('input[name="authType"]:checked').val() == "none") {
		if (!checkSaveStatus()) {
			return;
		}

		document.saveform.mode1.value = "none";
		setTimeout("document.saveform.submit()", 100);
	}
	else if ($('input[name="authType"]:checked').val() == "advanced") {
		SaveD(current_index, "true");
	}
}

function validate1(form) {
	if (isEmpty(form.find("input[name='name']").get(0))) {
		alert(i18n_ldap_msg4);
		form.find("input[name='name']").get(0).focus();
		return false;
	}

	if (isEmpty(form.find("input[name='server']").get(0))) {
		alert(i18n_ldap_msg2);
		form.find("input[name='server']").get(0).focus();
		return false;
	}

	if (!checkuserid(form.find("input[name='server']").get(0).value)) {
		alert(i18n_ldap_msg10);
		form.find("input[name='server']").get(0).focus();
		return;
	}

	if (isEmpty(form.find("input[name='pw']").get(0))) {
		alert(i18n_ldap_msg3);
		form.find("input[name='pw']").get(0).focus();
		return false;
	}

	var ip;
	var ips = form.find("input[name='ip']").get();

	var ports = form.find("input[name='port']").get();

	var enabled = form.find("input[name='enable']").attr("checked");
	var length = enabled ? 2 : 1;

	for (var i = 0; i < length; i++) {
		ip = Trim(ips[i].value);
		if (name == "" && !checkHostName(ip)) {
			alert(i18n_ldap_msg21);
			document.Saveform.ips[i].focus();
			return false;
		}
	}

	for (var i = 0; i < length; i++) {
		if (!ValidatePort(Trim(ports[i].value))) {
			alert(i18n_ldap_msg22);
			ports[i].focus();
			return false;
		}
	}

	if (form.find("input[name='mode']").get()[2].checked) {

		ip = Trim(form.find("input[name='realm']").val());
		if (!isHostname2(ip)) {
			alert(i18n_ldap_msg5);
			form.find("input[name='realm']").get(0).focus();
			return false;
		}

		ip = Trim(form.find("input[name='domain']").val());
		if (!isHostname2(ip)) {
			alert(i18n_ldap_msg6);
			form.find("input[name='domain']").get(0).focus();
			return false;
		}

		ip = Trim(form.find("input[name='adminServer']").val());
		if (!isHostname2(ip)) {
			alert(i18n_ldap_msg7);
			form.find("input[name='adminServer']").get(0).focus();
			return false;
		}

		if (!ValidatePort(Trim(form.find("input[name='portNumber']").val()))) {
			alert(i18n_ldap_msg22);
			form.find("input[name='portNumber']").get(0).focus();
			return false;
		}
	}
	return true;
}

function validate(form) {
	if (isEmpty(form.name)) {
		alert(i18n_ldap_msg4);
		form.name.focus();
		return false;
	}

	if (isEmpty(form.server)) {
		alert(i18n_ldap_msg2);
		form.server.focus();
		return false;
	}

	if (!checkuserid(form.server.value)) {
		alert(i18n_ldap_msg10);
		form.server.focus();
		return;
	}

	if (isEmpty(form.pw)) {
		alert(i18n_ldap_msg3);
		form.pw.focus();
		return false;
	}

	var ip;
	var ips = form.ip;

	var ports = form.port;

	var enabled = form.enable.checked;
	var length = enabled ? 2 : 1;

	for (var i = 0; i < length; i++) {
		ip = Trim(ips[i].value);
		if (name == "" && !checkHostName(ip)) {
			alert(i18n_ldap_msg21);
			document.Saveform.ips[i].focus();
			return false;
		}
	}

	for (var i = 0; i < length; i++) {
		if (!ValidatePort(Trim(ports[i].value))) {
			alert(i18n_ldap_msg22);
			ports[i].focus();
			return false;
		}
	}

	if (form.mode[2].checked) {

		ip = Trim(form.realm.value);
		if (!isHostname2(ip)) {
			alert(i18n_ldap_msg5);
			form.realm.focus();
			return false;
		}

		ip = Trim(form.domain.value);
		if (!isHostname2(ip)) {
			alert(i18n_ldap_msg6);
			form.domain.focus();
			return false;
		}

		ip = Trim(form.adminServer.value);
		if (!isHostname2(ip)) {
			alert(i18n_ldap_msg7);
			form.adminServer.focus();
			return false;
		}

		if (!ValidatePort(Trim(form.portNumber.value))) {
			alert(i18n_ldap_msg22);
			form.find("input[name='portNumber']").get(0).focus();
			return false;
		}
	}
	return true;
}

function sub(index) {
	if (!checkSaveStatus()) {
		return;
	}

	var form;
	if (index != -1) {
		form = document.getElementById("saveform" + index);
	}
	else {
		form = document.Saveform;
	}

	form.submit();
}

function SaveD(index, submit) {
	var form;
	if (index == -1) {
		form = $(document.Saveform);
		if (validate1(form)) {
			var hostnames = "";
			var ips = form.find("input[name='ip']").get();
			var ports = form.find("input[name='port']").get();
			var enabled = form.find("input[name='enable']").attr("checked");

			var length = enabled ? 2 : 1;
			for (var i = 0; i < length; i++) {
				var ip = Trim(ips[i].value);
				if (!isHostname2(ip)) {
					alert(i18n_ldap_msg21);
					ips[i].focus();
					return;
				}
				hostnames += (ip + ":" + ports[i].value);
				if (i < length - 1)
					hostnames += ";";
			}

			var status = 400;

			var vendor = form.find("select[name='serverType'] option:selected").val();
			if (vendor == undefined) {
				vendor = form.find("input[name='vendor']").val();
				switch (vendor.charAt(0)) {
					case 'M':
						vendor = 0;
						break;
					case 'L':
						vendor = 1;
						break;
					case 'N':
						vendor = 3;
						break;
					default:
						vendor = 2;
						break;
				}
			}

			var ldaps_mode;
			var v = Trim(form.find("select[name='ldaps_mode']").val());
			ldaps_mode = Trim(v);

			$.ajax({
				url : "rest/testConfiguration",
				type : "POST",
				async : false,
				data : {
					vendor : ldapList[vendor],
					hostname : hostnames,
					basedn : Trim(form.find("input[name='name']").val()),
					user : Trim(form.find("input[name='server']").val()),
					password : Trim(form.find("input[name='pw']").val()),
					LdapsMode: ldaps_mode,
					authmethod : form.find("input[name='mode']:checked").val(),
					kdcserver : Trim(form.find("input[name='adminServer']").val()) + ":"
							+ Trim(form.find("input[name='portNumber']").val()),
					kdcrealm : Trim(form.find("input[name='realm']").val()),
					kdcdomain : Trim(form.find("input[name='domain']").val())
				},
				complete : function(jqXHR, textStatus) {
					if ((status = jqXHR.status) != "200") {
						alert(i18n_ldap_wrong_config + jqXHR.responseText);
					}
				}
			});

			if (status != 200)
				return;

			var i = index >= 0 ? "save" : "add";
			form.find("input[name='op']").val(i);

			var var_expire_time = "120";
			var var_expire_type = "1";

			if (document.getElementsByName("cache")[0].checked) {
				var_expire_time = document.getElementById("ttl1").value;
				var_expire_type = "0";
			}
			else {
				var_expire_time = document.getElementById("ttl2").value;
				var_expire_type = "1";

			}

			form.find("input[name='expire_time']").val(var_expire_time);
			form.find("input[name='ttl_type']").val(var_expire_type);

			var var_fk_enable = "no";
			if (document.getElementById("enablefk").checked) {
				var_fk_enable = "yes";
			}
			else {
				var_fk_enable = "no";

			}
			form.find("input[name='fkenable']").val(var_fk_enable);


			var var_auth_method;
			var var_guest_enable;
			var var_cookie_enable;
			var var_captive_portal = document.getElementById("customizedHTML").value;

			if (document.getElementsByName("authentication_method")[0].checked) {
				var_auth_method = "0";
			}
			else
				var_auth_method = "1";

			if (document.getElementById("enableguest").checked) {
				var_guest_enable = "true";
			}
			else
				var_guest_enable = "false";

			if (document.getElementById("enablecookie").checked) {
				var_cookie_enable = "true";
			}
			else {
				var_cookie_enable = "false";
			}

			form.find("input[name='auth_method']").val(var_auth_method);
			form.find("input[name='captive_portal']").val(var_captive_portal);
			form.find("input[name='guest_enable']").val(var_guest_enable);
			form.find("input[name='cookie_enable']").val(var_cookie_enable);

			if (submit) {
				setTimeout("sub(" + index + ")", 100);
			}
			else {
				alert(i18n_ldap_hit1);
			}
		}
	}
	else {
		form = document.getElementById("saveform" + index);
		if ((index == -100) || validate(form)) {
			if (index != -100) {
				var hostnames = "";
				var ips = form.ip;
				var ports = form.port;
				var enabled = form.enable.checked;

				var length = enabled ? 2 : 1;
				for (var i = 0; i < length; i++) {
					var ip = Trim(ips[i].value);
					if (!isHostname2(ip)) {
						alert(i18n_ldap_msg21);
						ips[i].focus();
						return;
					}
					hostnames += (ip + ":" + ports[i].value);
					if (i < length - 1)
						hostnames += ";";
				}

				var status = 400;

				var vendor = form.serverType;
				var vendorol = form.serverType;
				if (vendorol != undefined) {
					var opts = vendorol.options;
					for (var i = 0; i < opts.length; i++) {
						var opt = opts[i];
						if (opt.selected) {
							vendor = opt.value;
						}
					}
				}

				if (vendor == undefined) {
					vendor = form.vendor.value;

					switch (vendor.charAt(0)) {
						case 'M':
							vendor = 0;
							break;
						case 'L':
							vendor = 1;
							break;
						case 'N':
							vendor = 3;
							break;
						default:
							vendor = 2;
							break;
					}
				}

				var mode;
				var modes = form.mode;
				for (var i = 0; i < 3; i++) {
					if (modes[i].checked)
						mode = modes[i].value;
				}

				var ldaps_mode;
				var v = form.ldaps_mode.value;
				ldaps_mode = Trim(v);

				$.ajax({
					url : "rest/testConfiguration",
					type : "POST",
					async : false,
					data : {
						vendor : ldapList[vendor],
						hostname : hostnames,
						basedn : Trim(form.name.value),
						user : Trim(form.server.value),
						password : Trim(form.pw.value),
						LdapsMode: ldaps_mode,
						authmethod : mode,
						kdcserver : Trim(form.adminServer.value) + ":" + Trim(form.portNumber.value),
						kdcrealm : Trim(form.realm.value),
						kdcdomain : Trim(form.domain.value)
					},
					complete : function(jqXHR, textStatus) {
						if ((status = jqXHR.status) != "200") {
							alert(i18n_ldap_wrong_config + jqXHR.responseText);
						}
					}
				});
				if (status != 200)
					return;
			}
			else {
				// form = $(document.Saveform);
				form = document.Saveform;
			}

			var i = index >= 0 ? "save" : "add";
			if (index == -100)
				i = "ignore";
			form.op.value = i;
			var var_expire_time = "120";
			var var_expire_type = "1";
			if (document.getElementsByName("cache")[0].checked) {
				var_expire_time = document.getElementById("ttl1").value;
				var_expire_type = "0";
			}
			else {
				var_expire_time = document.getElementById("ttl2").value;
				var_expire_type = "1";

			}
			form.expire_time.value = var_expire_time;
			form.ttl_type.value = var_expire_type;

			var var_fk_enable = "no";
			if (document.getElementById("enablefk").checked) {
				var_fk_enable = "yes";
			}
			else {
				var_fk_enable = "no";

			}

			form.fkenable.value = var_fk_enable;

			var var_auth_method;
			var var_guest_enable;
			var var_cookie_enable;
			var var_captive_portal = document.getElementById("customizedHTML").value;

			if (document.getElementsByName("authentication_method")[0].checked) {
				var_auth_method = "0";
			}
			else
				var_auth_method = "1";

			if (document.getElementById("enableguest").checked) {
				var_guest_enable = "true";
			}
			else
				var_guest_enable = "false";

			if (document.getElementById("enablecookie").checked) {
				var_cookie_enable = "true";
			}
			else {
				var_cookie_enable = "false";
			}

			form.auth_method.value = var_auth_method;
			form.captive_portal.value = var_captive_portal;
			form.guest_enable.value = var_guest_enable;
			form.cookie_enable.value = var_cookie_enable;

			if (submit) {
				if (index == -100)
					setTimeout("sub(" + -1 + ")", 100);
				else
					setTimeout("sub(" + index + ")", 100);
			}
			else {
				alert(i18n_ldap_hit1);
			}
		}
	}
}


function doUpload()
{
	if (!document.getElementById("button1111").disabled)
	{
		alert(i18n_save_first);
		return;
	}
	
	if(document.getElementById("uploadingKeytab") != "") {
		document.mainForm.encoding="multipart/form-data";
		document.mainForm.action = "servlet/com.trend.iwss.gui.servlet.UploadKeyTabFile?action=upload";
		setTimeout( "document.mainForm.submit()", 100 );
	}
}
