var i18n = {
	"skynet": {
		"register": {
			"MSG_UNKNOWN_COMMAND_ARGUMENT": "Incorrect Parameter",
			"ClientChannel_2": "The registration token has expired",
			"ClientChannel_3": "Incorrect parameter or token is invalid",
			"ClientChannel_19": "Incorrect parameter or token is invalid",
			"ClientChannel_4": "The gateway name has already been taken by another gateway",
			"ClientChannel_25": "The request is timeout",
			"ClientChannel_46": "No more seat available, please try another token",
			"ClientChannel_57": "Web Security Hybrid license has expired",
			"MSG_MUST_DISABLE_LOG_REPLICA": "IWS cannot register to IWSH when log replication is enabled",
			"MSG_MUST_DISABLE_CONF_REPLICA": "IWS cannot register to IWSH when configuration replication is enabled",
			"ClientChannel_others": "The registration request is failed(Unexpected internal error)"
		},
		"unregister": {
			"ClientChannel_4": "The gateway is not allowed to unregister",
			"ClientChannel_25": "The request is timeout",
			"ClientChannel_57": "Web Security Hybrid license has expired",
			"ClientChannel_others": "The registration request is failed(Unexpected internal error)"
		},
		"force_unregister": {
			"ClientChannel_57": "Web Security Hybrid license has expired",
			"MSG_FAILED_TO_UNREGISTER": "Failed to unregister from IWSH",
			"ClientChannel_others": "Force unregister from IWSH failed"
		},
		"test_conn": {
			"result": "Connection failed!"
		},
		"online": "Online",
		"offline": "Offline"
	},
	"common": {
		"NO_DATA": "--",
		"PRODUCT": {
			"FULL_NAME": "Trend Micro InterScan Web Security Appliance"
		},
		"FREQUENCY": {
			"MONTHS": "Month(s)",
			"WEEKS": "Week(s)",
			"DAYS": "Day(s)",
			"ONCE": "Once",
			"DAILY": "Daily",
			"WEEKLY": "Weekly",
			"MONTHLY": "Monthly",
			"RUNNOW": "Run Now"
		},
		"LABEL" : {
			"ADD": "Add",
			"COPY": "Copy",
			"DELETE": "Delete",
			"SAVE": "Save",
			"YES": "Yes",
			"NO": "No"
		},
		  "COLON_LABEL": {
			"ENABLE": "Enable:",
			"DESCRIPTION": "Description:"
		}
	},
	"report_logsetting": {
		"PAGE_TITLE": "Log Settings",
		"MESSAGE": {
			"SAVE_PURGE_SETTINGS_SUCCESS": "Global Log Settings Successfully Saved!",
			"SAVE_FILTER_SETTINGS_SUCCESS": "Global Log Filter Successfully Saved!",
			"CLEAR_FILTER_SETTINGS_SUCCESS": "Global Log Filter Successfully Cleared!",
			"PURGE_SETTINGS_INPUT_INVALID": "Invalid Input! Positive Number Is Required!",
			"PURGE_SETTINGS_INPUT_INVALID_SIZE": "Invalid Input! Log Disk Size Must Not Be Larger Than Var Partition!",
			"ANONYMOUS_SUCESS":"Successfully Setting",
			"NO_CHANGE": "No Change Happened.",
			"VALUE_NOT_EMPTY":"value must not be empty !",
			"RULE_ALREADY_EXIST":"Rule already exists !",
			"MOUNT_ACTION_SUCCESS": "Mount action success",
			"UNMOUNT_ACTION_SUCCESS": "Unmount action success",
			"MOUNT_ACTION_UNSUCCESS": "Mount action unsuccess! Modify the mount info and try it again.",
			"UNMOUNT_ACTION_UNSUCCESS": "Unmount action unsuccess! Try it again later.",
			"NO_FOLDER_TO_RETRIEVAL": "There is no folder can be import",
			"WARN_MOUNT_DEVICE_FIRST": "Please mount a device first and then enable log offload.",
			"WARN_ENABLE_LOG_OFFLOAD": "When enable log offload the purge days must large than 45.",
			"WARN_DISABLE_HISTORICAL_REPORT_MODE": "Delete all the retrieval logs first before disable historical_report_mode",
			"MOUNT_DEVICE_ERROR": "The mount device info contains invalid characters",
			"UMOUNT": "umount",
			"MOUNT": "mount",
			"UMOUNT_IS_NOT_ALLOWED": "Disable log offload first then umount device.",
			"RETRIEVE_LOGS": "Retrieve Logs",
			"RETRIEVAL_LOGS": "Select historical logs",
			"CHOOSE_FOLDER_FIRST": "Please choose a folder first."
		},
		"COLON_LABEL": {
			"STORE_LOGS_FOR": "Store logs for:",
			"MAX_LOG_DISK_SIZE": "Maximum logs disk size:"
		},
		"TITLE": {
			"GLOBAL_LOG_SETTINGS": "Global Log Settings",
			"GLOBAL_LOG_FILTER": "Global Log Filter",
			"ANONYMOUS_LOG": "Anonymous Logging",
			"INTERRUPTED_LOG": "Interrupted Logging",
			"SYSLOG_SERVER": "Syslog Server <span style='font-weight:normal;'>(if configured, logs will be redirected to these syslog servers.)</span>"
		},
		"OPTION": {
			"GLOBAL_LOG_SETTINGS_Bandwidth":"Bandwidth",
			"GLOBAL_LOG_SETTINGS_Enforcement":"Policy Enforcement",
			"GLOBAL_LOG_SETTINGS_Internet_Access":"Internet Access",
			"GLOBAL_LOG_SETTINGS_Internet_Security":"Internet Security",
			"GLOBAL_LOG_SETTINGS_Data_Security":"Data Security",
			"GLOBAL_LOG_SETTINGS_Access_Control":"Access Control",
			"GLOBAL_LOG_SETTINGS_user":"User Name",
			"GLOBAL_LOG_SETTINGS_dom":"Domain"
		},
		"ANONYMOUS_INFO":"Anonymous logging is currently",
		"INTERRUPTED_INFO":"Interrupted logging is currently",
		"GB_RECOMMENDED": "5GB Recommended",
		"INFO_LOG_EXCEED": "<strong>Note:</strong> If log data exceed the size specified, older log data will be deleted automatically for newer log data. To help free storage, log data older than the specified days will also be deleted."
	},
	"favorites_log": {
		"PAGE_TITLE": "Log Analysis Favorites",
		"NAME": "Name",
		"DESCRIPTION": "Description",
		"TYPE": "Type",
		"FILTERS": "Filters",
		"MESSAGE": {
			"NO_FAVORITE_SELECTED": "You must first select a favorite report template.",
			"CONFIRM_DELETE": "Are you sure you want to delete the selected favorite(s) ?"
		}
	},
	"reports": {
		"PAGE_TITLE": "Reports",
		"REPORT_NAME": "Report Name",
		"PERIOD": "Period",
		"GENERATE_REPORT": "Generate Report",
		"LAST_GENERATED": "Saved Reports",
		"NEXT_REPORT_ON": "Next Report On",
		"LAST_X": "Last ",
		"RUN_NOW": "Run Now",
		"STATUS" : {
			"RUNNING": "Processing...",
			"FAILED": "Failed",
			"SUCCESS": "Successful & refreshing..."
		},
		"MESSAGE": {
			"NO_REPORTS_SELECTED": "No reports selected. Please try again.",
			"CONFIRM_COPY": "Are you sure you want to copy the selected report(s) ?",
			"CONFIRM_DELETE": "Are you sure you want to delete the selected report(s) ?",
			"REPORT_TYPE_NONE": "The Report Type is None. Please select a different type.",
			"REPORT_TOPN_RANGE": "Top N must be a positive value with a range of 1 to 99",
			"NAME_LENGTH_CONTROL": "Name lengths should not exceed 256 characters.",
			"REPORT_SUCCESS_CREATED": "The report was created successfully.",
			"REPORT_SUCCESS_UPDATED": "The report was updated successfully."
		}
	},
	"half_part": {
		"HALF_BLANK_WARN": "' cannot be blank!",
		"HALF_VALID_EMAIL_WARN": "' needs to include a valid email address.",
		"HALF_REPORT_WITH_NAME": "A report with the name '",
		"HALF_REPORT_RENAME": "' already exists. Would you like to rename it to '",
		"HALF_VALID_WARN":  "' contains invalid charactors!"
	},
	"report_action": {
		"PAGE_TITLE": {
			"MODIFY": "Reports: Modify Report",
			"ADD": "Reports: Add Report",
			"NEW_REPORT": "New Report"
		},
		"TITLE": {
			"REPORTS": "Reports",
			"REPORT_INFO": "Report Information"
		},
		"COLON_LABEL": {
			"REPORT_NAME": "Report Name:"
		},
		"MESSAGE": {

		},
		"report_title": {
			"internet_security": "Internet Security",
			"internet_access": "Internet Access",
			"bandwidth": "Bandwidth",
			"policy_enforcement": "Policy Enforcement",
			"data_security": "Data Security",
			"custom_report": "Custom Reports"
		},
		"report_data": {
			"reports": {
				"internet_security": [
					["top_malware_spyware_detection",                 10,true,[0], [0,2], "Top N Malware Spyware Detection"                  ],
					["top_botnet_detection",                          10,true,[0], [0,2], "Top N Botnet Detection"                           ],
					["top_advanced_threats_detection",                10,true,[0], [0,2], "Top N Document Exploit APT Detection"             ],
					["top_custom_defense_apt_blocking",               10,true,[0], [0,2], "Top N Custom Defense APT Blocking"                ],
					["c&c_contact_alert_count_by_date",                0,true,[0], [0]  , "C&C Contact Alert Count by Date"                  ],
					["top_c&c_contact_ip_domains",                    10,true,[0], [0,2], "Top N C&C Address"                                ],
					["top_users_hosts_detected_by_c&c_contact_alert", 10,true,[0], [0,2], "Top N Users Hosts Detected by C&C Contact Alert"  ],
					["top_groups_detected_by_c&c_contact_alert",      10,true,[0], [0,2], "Top N Groups Detected by C&C Contact Alert"       ],
					["top_malicious_sites_blocked",                   10,true,[0], [0,2], "Top N Malicious Sites Blocked"                    ],
					["top_users_blocked_by_malware_spyware",          10,true,[0], [0,2], "Top N Users Blocked by Malware Spyware"           ],
					["top_users_blocked_by_malicious_sites",          10,true,[0], [0,2], "Top N Users Blocked by Malicious Sites"           ],
					["top_groups_blocked_by_malware_spyware",         10,true,[0], [0,2], "Top N Groups Blocked by Malware Spyware"          ],
					["top_groups_blocked_by_malicious_site",          10,true,[0], [0,2], "Top N Groups Blocked by Malicious Site"           ],
					["top_users_by_bot_net_detection",                10,true,[0], [0,2], "Top N Users by Botnet Detection"                  ],
					["most_violation_for_http_malware_scan_policy",    0,true,[0], [0,2], "Most Violation for HTTP Malware Scan Policy"      ],
					["malicious_sites_blocked_by_date",                0,true,[2], [2]  , "Malicious Sites Blocked by Date"                  ],
					["malware_spyware_detection_by_date",              0,true,[2], [2]  , "Malware Spyware Detection by Date"                ],
					["malware_spyware_detection_trend",                0,true,[3], [3]  , "Malware Spyware Detection Trend"                  ]
				],
				"internet_access": [
					["top_applications_visited",                      10,true,[0], [0,2], "Top N Applications Visited"                       ],
					["top_url_categories_visited",                    10,true,[0], [0,2], "Top N URL Categories Visited"                     ],
					["top_sites_visited",                             10,true,[0], [0,2], "Top N Sites Visited"                              ],
					["top_users_by_requests",                         10,true,[0], [0,2], "Top N Users by Requests"                          ],
					["top_groups_by_requests",                        10,true,[0], [0,2], "Top N Groups by Requests"                         ],
					["top_url_categories_by_browse_time",             10,true,[0], [0,2], "Top N URL Categories by Browse Time"              ],
					["top_sites_visited_by_browse_time",              10,true,[0], [0,2], "Top N Sites Visited by Browse Time"               ],
					["top_users_by_browse_time",                      10,true,[0], [0,2], "Top N Users by Browse Time"                       ],
					["activity_level_by_days",                        0,true,[5], [2,5], "Activity Level by Days"                            ]
				],
				"bandwidth": [
					["top_url_categories_by_bandwidth",               10,true,[0], [0,2], "Top N URL Categories by Bandwidth"                ],
					["top_applications_by_bandwidth",                 10,true,[0], [0,2], "Top N Applications by Bandwidth"                  ],
					["top_users_by_bandwidth",                        10,true,[0], [0,2], "Top N Users by Bandwidth"                         ],
					["top_groups_by_bandwidth",                       10,true,[0], [0,2], "Top N Groups by Bandwidth"                        ],
					["top_sites_by_bandwidth",                        10,true,[0], [0,2], "Top N Sites by Bandwidth"                         ],
					["total_traffic_by_days",                          0,true,[3], [2,3], "Total Traffic by Days"                            ]
				],
				"policy_enforcement": [
					["top_url_categories_blocked",                    10,true,[0], [0,2], "Top N URL Categories Blocked"                     ],
					["top_applications_blocked",                      10,true,[0], [0,2], "Top N Applications Blocked"                       ],
					["top_users_enforced",                            10,true,[0], [0,2], "Top N Users Enforced"                             ],
					["top_groups_enforced",                           10,true,[0], [0,2], "Top N Groups Enforced"                            ],
					["top_sites_blocked",                             10,true,[0], [0,2], "Top N Sites Blocked"                              ],
					["top_users_by_http_inspection",                  10,true,[0], [0,2], "Top N Users by HTTP Inspection"                   ],
					["most_violation_for_url_filtering_policy",        0,true,[0], [0,2], "Most Violation for URL Filtering Policy"          ],
					["most_violation_for_application_control_policy",  0,true,[0], [0,2], "Most Violation for Application Control Policy"    ],
					["most_violation_for_access_quota_control_policy", 0,true,[0], [0,2], "Most violation for Access Quota Control Policy"   ],
					["most_violation_for_applets_and_activex_policy",  0,true,[0], [0,2], "Most violation for Applets and ActiveX policy"    ],
					["most_violation_for_http_inspection_policy",      0,true,[0], [0,2], "Most violation for HTTP Inspection Policy"        ]
				],
				"data_security": [
					["top_dlp_templates_blocked_by_requests",         10,true,[2], [2],   "Top N DLP Templates Blocked by Requests"          ],
					["top_blocked_users",                             10,true,[0], [0,2], "Top N Blocked Users"                              ],
					["top_blocked_groups",                            10,true,[0], [0,2], "Top N Blocked Groups"                             ],
					["most_violation_for_data_loss_prevention_policy", 0,true,[0], [0,2], "Most Violation for Data Loss Prevention Policy"   ]
				]
			}
		}
	}
}
