<!--++++++++++++++++++++++++++++++++++++++++++++++++++++++++-->
<!--Modified by: John Shih                                  -->
<!--Date: 11/09/2006                                        -->
<!--Description: Validation the E-Mail address              -->
<!--File:notifications_smtp.jsp                             -->
<!--++++++++++++++++++++++++++++++++++++++++++++++++++++++++-->
<%@ page contentType = "text/html; charset=UTF-8" %>
<%@ page import="com.trend.iwss.gui.*" %>
<%@ taglib uri="http://jakarta.apache.org/taglibs/i18n-1.0" prefix="i18n" %>
<i18n:bundle baseName="iwsvaNotifications" id="bundleNotification" />
<i18n:bundle baseName="iwsvaCommon" id="bundleCommon" />
<%
    if(Validation.CheckUser(request,response)!=1){
        response.sendRedirect("logon.jsp");
        return;
    }
    response.setHeader("Pragma","no-cache");
    response.setHeader("Cache-Control","no-cache");
%>
<html>
<head>
<META HTTP-EQUIV="content-type" CONTENT="text/html; charset=UTF-8">
<title>Trend Micro InterScan Web Security Virtual Appliance</title>

<link href="html/trend-style.css" rel="stylesheet" type="text/css">
<SCRIPT language="javascript" src="html/func.js"></SCRIPT>
<SCRIPT language="javascript" src="html/i18n_warnmsg.js"></SCRIPT>
<SCRIPT LANGUAGE="JavaScript">
// check format
function checkEmailAddress(str)
{
	if (0 == str.length)
		return true;
	// invalid char
	var filter1 = /[^\x00-\x32\x7F<>(),;:\"\\]/;
	// invalid case
	var filter2 = /\.\.|^\.|\.$|\.@|@\.|@.*@/;
	// valid format
	var filter3 = /^[a-zA-Z0-9][\w-]*(\.[\w-]+)*@([a-zA-Z0-9]+([\w-]*[a-zA-Z0-9])?(\.[a-zA-Z0-9]+([\w-]*[a-zA-Z0-9])?)*(\.[a-zA-Z0-9]+([\w-]*[a-zA-Z0-9])?)$|\[[1-9][0-9]{0,2}(\.(0|[1-9][0-9]{0,2})){2}\.[1-9][0-9]{0,2}\]$)/;
	if (filter1.test(str)
		&& !filter2.test(str))
	{
		if (filter3.test(str))
			return true;
	}
	return false;
}
function replace(string,text,by) {
// Replaces text with by in string
    var strLength = string.length, txtLength = text.length;
    if ((strLength == 0) || (txtLength == 0)) return string;

    var i = string.indexOf(text);
    if ((!i) && (text != string.substring(0,txtLength))) return string;
    if (i == -1) return string;

    var newstr = string.substring(0,i) + by;

    if (i+txtLength < strLength)
        newstr += replace(string.substring(i+txtLength,strLength),text,by);

    return newstr;
}
function checkfields()
{
    document.saveform.notification__to_addr.value = Trim(document.saveform.notification__to_addr.value);
    document.saveform.http__dlp_alert_receiver.value = Trim(document.saveform.http__dlp_alert_receiver.value);
    document.saveform.notification__from_addr.value = Trim(document.saveform.notification__from_addr.value);
    document.saveform.notification__server.value = Trim(document.saveform.notification__server.value);
    document.saveform.notification__port.value = Trim(document.saveform.notification__port.value);
    document.saveform.notification__interval.value = Trim(document.saveform.notification__interval.value);
from_email_address = document.saveform.notification__from_addr.value;
//alert(checkEmailAddress(from_email_address));

    /* legacy case merge
    if(checkEmailAddress(from_email_address) == false)
    {
            alert(i18n_valid_from_email);
            document.saveform.notification__from_addr.focus();
            return false;
    }*/

to_email_address = document.saveform.notification__to_addr.value;
dlp_to_email_address = document.saveform.http__dlp_alert_receiver.value;
var to_email_array = new Array();
var dlp_to_email_array = new Array();
to_email_array = to_email_address.split(',');
to_email_len = to_email_array.length;
dlp_to_email_array = dlp_to_email_address.split(',');
dlp_to_email_len = dlp_to_email_array.length;
for(i=0; i < to_email_len;i++)
{
    if(checkEmailAddress(to_email_array[i]) == false)
    {
            alert(i18n_valid_to_email);
            document.saveform.notification__to_addr.focus();
            return false;
    }	
}//end of for(i=0; i < to_email_len;i++)	
	
for(i=0; i < dlp_to_email_len;i++)
{
    if(checkEmailAddress(dlp_to_email_array[i]) == false)
    {
            alert(i18n_valid_to_email);
            document.saveform.http__dlp_alert_receiver.focus();
            return false;
    }	
}//end of for(i=0; i < to_email_len;i++)	
    if(document.saveform.notification__from_addr.value=="")
    {
            alert(i18n_smtp_from);
            document.saveform.notification__from_addr.focus();
            return false;
    }
    if(document.saveform.notification__to_addr.value=="")
    {
            alert(i18n_smtp_to);
            document.saveform.notification__to_addr.focus();
            return false;
    }	
    if(document.saveform.notification__server.value=="" || ISDBCS(document.saveform.notification__server.value))
    {
            alert(i18n_smtp_server);
            document.saveform.notification__server.focus();
            return false;
    }

    if(!ValidatePort(document.saveform.notification__port.value))
    {
        alert(i18n_valid_port);
        document.saveform.notification__port.focus();
        return;
    }

    if(!CheckIntegerM(document.saveform.notification__interval.value,0))
    {
        alert(i18n_mail_queue);
        document.saveform.notification__interval.focus();
        return;
    }

    return true;    
}

function doSubmit()
{
    if(!checkfields()) return;
    if(document.saveform.use_ehlo_view.checked) document.saveform.notification__use_ehlo.value = "yes";
    else document.saveform.notification__use_ehlo.value = "no";
    if(document.saveform.use_auth.checked) document.saveform.notification__use_auth.value = "yes";
    else document.saveform.notification__use_auth.value = "no";
    document.saveform.daemonaction.value = mailrestart+httpreloadplus+ftpreloadplus+haagentreload;
    document.saveform.op.value="mailsetting";
    setTimeout( "document.saveform.submit()", 100 );
}

</script>

</head>


<body bgcolor="#FFFFFF" leftmargin="0" topmargin="0" marginwidth="0" marginheight="0">
<FORM ACTION="servlet/com.trend.iwss.gui.servlet.interscanset" METHOD=POST NAME=saveform>
<input type=hidden name="op" value="mailsetting">
<input type="hidden" name="fromurl" value="/notifications_smtp.jsp">
<input type=hidden name="daemonaction" value="0">
<table width="540" border="0" cellspacing="0" cellpadding="0">
  <tr> 
    <td width="507" class="content-title">
<i18n:message bundleRef="bundleNotification" key="notifications_smtp.title" /></td>
    <td width="33" valign="bottom"> 
      <div align="right"><A href="javascript:openhelpwin('notifications_smtp.htm');"><img src="images/question_cui.gif" width="18" height="18" border="0"></a></div></td>
  </tr>
  <tr>
    <td colspan="2" class="hor-dotted-line"><img src="images/1space_cui.gif" width="1" height="10"></td>
  </tr>
  <tr>
    <td colspan="2" class="data1"><a href="notifications.jsp"><i18n:message bundleRef="bundleNotification" key="notification_events.notifications" /></a>      &gt; <i18n:message bundleRef="bundleNotification" key="notifications_smtp.second_title" /></td>
  </tr>
  <tr>
    <td colspan="2"><img src="images/1space_cui.gif" width="1" height="10"></td>
  </tr>
</table>
<table width="540" border="0" cellpadding="0" cellspacing="0" class="border">
  <tr>
    <td><table width="600" border="0" cellpadding="0" cellspacing="0">
      <tr>
        <td width="600" class="tableheadergrey"><i18n:message bundleRef="bundleNotification" key="notifications_smtp.email_setting.title" /></td>
      </tr>
      <tr>
        <td style="padding-top:3px"><table width="600" border="0" cellspacing="0" cellpadding="0">

            <tr>
              <td class="data1"><i18n:message bundleRef="bundleNotification" key="notifications_smtp.email_setting.sender_address" /></td>
              <td class="data1">
                <input name="notification__from_addr" type="text" class="button" value="<%=IWSSUtil.MyReplace(IWSSInfo.GetKeyValue("notification","from_addr"),"\"","&quot;")%>" size="60" maxlength="256" onKeyDown="EnableSaveButton();">
              </td>
            </tr>				
		
            <tr>
              <td width="230" class="data1"><i18n:message bundleRef="bundleNotification" key="notifications_smtp.email_setting.send_to" /></td>
              <td class="data1">
                <input name="notification__to_addr" type="text" class="button" value="<%=IWSSUtil.MyReplace(IWSSInfo.GetKeyValue("notification","to_addr"),"\"","&quot;")%>" size="60" maxlength="512" onKeyDown="EnableSaveButton();">
              </td>
            </tr>
            <tr>
              <td>&nbsp;</td>
              <td valign="top" class="data1"><i18n:message bundleRef="bundleNotification" key="notifications_smtp.email_setting.use_a_comma" /></td>
            </tr>

 			<tr>
              <td width="230" class="data1"><i18n:message bundleRef="bundleNotification" key="notifications_smtp.email_setting.send_dlp_to" /></td>
              <td class="data1">
                <input name="http__dlp_alert_receiver" type="text" class="button" value="<%=IWSSUtil.MyReplace(IWSSInfo.GetKeyValue("http","dlp_alert_receiver"),"\"","&quot;")%>" size="60" maxlength="512" onKeyDown="EnableSaveButton();">
              </td>
            </tr>
            <tr>
              <td>&nbsp;</td>
              <td valign="top" class="data1"><i18n:message bundleRef="bundleNotification" key="notifications_smtp.email_setting.use_a_comma" /></td>
            </tr>
            
            <tr>
              <td class="data1"><i18n:message bundleRef="bundleNotification" key="notifications_smtp.email_setting.server_address" />&nbsp;</td>
              <td class="data1">
                <input name="notification__server" type="text" class="button" value="<%=IWSSUtil.MyReplace(IWSSInfo.GetKeyValue("notification","server"),"\"","&quot;")%>" size="60" maxlength="256" onKeyDown="EnableSaveButton();">
              </td>
            </tr>
            <tr>
              <td class="data1"><i18n:message bundleRef="bundleNotification" key="notifications_smtp.email_setting.server_port" /></td>
              <td class="data1">
               <input name="notification__port" type="text" class="button" value="<%=IWSSInfo.GetKeyValue("notification","port")%>" size="5" maxlength="5" onKeyDown="EnableSaveButton();">
              </td>
            </tr>
            <tr>
              <td class="data1"><i18n:message bundleRef="bundleNotification" key="notifications_smtp.email_setting.mins_to_check" /></td>
              <td class="data1">
                 <input name="notification__interval" type="text" class="button" value="<%=IWSSInfo.GetKeyValue("notification","interval")%>" size="5" maxlength="5" onKeyDown="EnableSaveButton();">
              </td>
            </tr>
            <tr>
              <td colspan="2" class="data1">
                <input type=hidden name="notification__use_ehlo" value="<%=IWSSInfo.GetKeyValue("notification","use_ehlo")%>">
                <input type="checkbox" name="use_ehlo_view" value="yes"<%if(IWSSInfo.GetKeyValue("notification","use_ehlo").compareToIgnoreCase("yes")==0){%> checked<%}%> onClick="EnableSaveButton();">
            <i18n:message bundleRef="bundleNotification" key="notifications_smtp.email_setting.use_hello_to_identify" /></td>
            </tr>
            <tr>
              <td colspan="2" class="data1">
                <input type=hidden name="notification__use_auth" value="<%=IWSSInfo.GetKeyValue("notification","use_auth")%>">
                <input type="checkbox" id="use_auth" value="yes" <%if(IWSSInfo.GetKeyValue("notification","use_auth").compareToIgnoreCase("yes")==0){%> checked<%}%> onClick="EnableSaveButton();">
                Enable SMTP AUTH</td>
            </tr>
            <tr id="auth_password">
              <td class="data1">Auth Password&nbsp;</td>
              <td class="data1">
                <input name="notification__auth_password" type="text" class="button" value="<%=IWSSInfo.GetKeyValue("notification","auth_password")%>" size="60" maxlength="256" onKeyDown="EnableSaveButton();">
              </td>
            </tr>
          </table>
        </td>
      </tr>
    </table></td>
  </tr>
</table>
<table width="540" border="0" cellspacing="0" cellpadding="0">
  <tr> 
    <td height="28" valign="bottom">
<%=AccessLevel.BUTTON(request, response, "save", "button", "javascript:doSubmit();", MessageResourcesMgr.mrCommon.getMessage("button.save"), "disabled")%>
      <input name="cancel"  type="button"  onclick="javascript:self.location.replace('notifications_smtp.jsp')"  class="button" value="<i18n:message bundleRef='bundleCommon' key='button.cancel' />"> 
    </td>
  </tr>
</table>

<script language="javascript" type="text/javascript" src="html/jquery.js"></script>
<script>

$(document).ready(function() {
        if($("#use_auth").attr("checked")) {
            $("#auth_password").show();

        }
        else {
            $("#auth_password").hide();
        }
        $("#use_auth").bind("change", function(e) {
            if ($(this).attr("checked")){
                $("#auth_password").show();
            }else {
                $("#auth_password").hide();
            }

        });	
        $("use_auth").trigger("change");

});

</script>

</body>
</form>


</html>
