<%@ page contentType = "text/html; charset=UTF-8" %>
<%@ page import="com.trend.iwss.gui.*" %>
<%@ page import="com.trend.iwss.policy.*" %>
<%@ page import="com.trend.api.administration.*" %>
<%@ page import="java.util.*" %>
<%
	Collection allPeriodList = TimePeriod.getAllTimePeriods();
%>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge" >
<title i18n="PRODUCT.FULL_NAME"></title>
<link href="html/trend-style.css" rel="stylesheet" type="text/css">
<link href="lib/tmPlugins/jquery-ui-1.9.2.custom.min.css" rel="stylesheet" type="text/css">
<link href="lib/tmPlugins/ui.dynatree.css" rel="stylesheet" type="text/css">
<link href="lib/tmPlugins/styles.css" rel="stylesheet" type="text/css">
</head>
<script language="Javascript" type="text/javascript" src="html/func.js"></script>
<script language="JavaScript" type="text/javascript" src="html/i18n_warnmsg.js"></script>

<%
	AdministrationAccount accountinfo = (AdministrationAccount)request.getSession().getAttribute("AccountInfo");
	AdministrationRole roleinfo = null;
	int access = 0;
	if(accountinfo != null)
	{
		roleinfo = accountinfo.getRole();
		access = roleinfo.getAccessRightByKeyID(7);
		if (access == 0)
		{
			response.sendRedirect("logon.jsp");
			return;
		}
	}
	else
	{
		response.sendRedirect("logon.jsp");
		return;
	}
	
	IWSSINI report_config = new IWSSINI("/usr/iwss/schedule_report/config/report_config.ini");
	String full_report = report_config.GetKeyValue("report", "full_report");

%>

<%
	response.setHeader("Pragma","no-cache");
	response.setHeader("Cache-Control","no-cache");
%>

<body bgcolor="#FFFFFF" leftmargin="0" topmargin="0" marginwidth="0" marginheight="0">
<table cellspacing=0 cellpadding=0 width=98% border=0>
	<tr>
		<td width="933" class="content-title" id="content-title"></td>
		<td width="19" valign="bottom">
			<div align="right">
				<a href="javascript:openhelpwin('reports_add.htm');" id="help_link">
					<img src="images/question_cui.gif" width="18" height="18" border="0"></a></div>
		</td>
	</tr>
	<tr>
		<td colspan="2" class="hor-dotted-line"><img src="images/1space_cui.gif" width="1" height="10"></td>
	</tr>
	<tr>
		<td colspan="2" class="data1"><a href="reports.jsp" i18n="TITLE.REPORTS"></a> &gt; <span id="report_name"></span></td>
	</tr>
	<tr>
		<td colspan="2" class="data1" id="alert_div"></td>
	</tr>
</table>
<table width="98%" border="0" cellpadding="0" cellspacing="0" class="border">
<tbody>
<tr>
<td>
<table width="100%" border="0" cellspacing="0" cellpadding="0">
<tbody>
<tr>
	<td class="tableheader" i18n="TITLE.REPORT_INFO"></td>
</tr>
<tr>
	<td class="data1" style="padding-bottom:10; padding-top:10;">
		<table border="0" cellspacing="2" cellpadding="2">
			<tr>
				<td width="110"><label for="json-report-name" i18n="COLON_LABEL.REPORT_NAME"></label></td>
				<td><input type="text" class="button" id="json-report-name" maxlength="255"></td>
			</tr>
			<tr>
				<td style="vertical-align:top;"><label for="json-report-description" i18n="COLON_LABEL.DESCRIPTION"></label></td>
				<td><textarea class="button" id="json-report-description" rows="3"></textarea></td>
			</tr>
			<tr>
				<td><label for="json-report-enable" i18n="COLON_LABEL.ENABLE"></label></td>
				<td>
					<select id="json-report-enable">
						<option value="true" i18n="LABEL.YES"></option>
						<option value="false" i18n="LABEL.NO"></option>
					</select>
				</td>
			</tr>
		</table>
	</td>
</tr>
<tr>
	<td width="538" class="tableheadergrey2">Report Settings</td>
</tr>
<tr>
	<td>
		<table border="0" cellspacing="2" cellpadding="2">
			<tr>
				<td width="110" style="vertical-align: top;"><label for="json-report-frequency">Generate report:</label>
				</td>
				<td>
					<label for="json-report-frequency">Schedule for </label>
					<select id="json-report-frequency">
						<option value="0" selected>Once Now</option>
						<option value="1">Once in Future</option>
						<option value="2">Every Day</option>
						<option value="3">Every Week</option>
						<option value="4">Every Month</option>
					</select>

					<div id="report_on_demand_container" style="position:relative;display:none;">
						<label for="report_start_datetime">on (date) </label>
						<input type="text" id="report_start_datetime" style="width:150px;"/>
					</div>
					<input type="hidden" id="json-report-scheduled"/>
					<input type="hidden" id="json-report-start_date"/>
					<input type="hidden" id="json-report-runtime"/>
					<input type="hidden" id="full_report" value="<%=full_report%>">

					<div id="report_scheduled" style="display:none;">
						<span id="report_day_of_week_container">
						  <label for="report_day_of_week">on</label>
						  <select id="report_day_of_week">
							  <option value="0" selected>Sunday</option>
							  <option value="1">Monday</option>
							  <option value="2">Tuesday</option>
							  <option value="3">Wednesday</option>
							  <option value="4">Thursday</option>
							  <option value="5">Friday</option>
							  <option value="6">Saturday</option>
						  </select>
						</span>
						<span id="report_day_of_month_container">
						  <label for="report_day_of_month">on the</label>
						  <select id="report_day_of_month">
						  </select>
						</span>
						<span style="position:relative">
						  <label for="report_start_time">at (time) </label>
						  <input type="text" id="report_start_time" style="width:75px;"/>
						</span>
						<table border="0" cellspacing="2" cellpadding="2"
							   style="padding:5px 0;margin:5px 0;border-top:1px solid #CCC;border-bottom:1px solid #CCC;">
							<tr>
								<td><label for="report_start_date">Start generating on: </label></td>
								<td>
									<div style="position:relative;">
										<input type="text" id="report_start_date"/>
									</div>
								</td>
							</tr>
							<tr>
								<td><label for="report_stop_generate">Stop generating: </label></td>
								<td>
									<select id="report_stop_generate">
										<option value="0" selected>Never</option>
										<option value="1">After</option>
									</select>
							  <span id="report_generate_occurrences_container" style="display:none;">
								<input type="text" id="json-report-max_exec_number" style="width:50px" value="0"/> occurrences
								<input type="hidden" id="report_generate_occurrences_original" value="--"/>
							  </span>
								</td>
							</tr>
						</table>
					</div>
				</td>
			</tr>
			<tr>
				<td width="110" style="vertical-align: top;"><label for="json-report-period">Report Period:</label></td>
				<td>
				  <table border="0">
					<tr>
					  <td colspan="2">
						<input type="radio" checked name="period_type" value="canned"> Last
						<select name="canned_period_number" id="canned_period_number">
						  <option value="1">1</option>
						  <option value="2">2</option>
						  <option value="3">3</option>
						  <option value="4">4</option>
						  <option value="5">5</option>
						</select>
						<select name="canned_period_type" id="canned_period_type">
						  <option value="D">day(s)</option>
						  <option value="W">week(s)</option>
						  <option value="M">month(s)</option>
						</select>
					  </td>
					</tr>
					<tr>
					  <td>
						<input type="radio" name="period_type" value="custom"> Custom Time Range:
					  </td>
					  <td>
						<div id="report_period"></div>
					  </td>
					</tr>
				  </table>
				  <input type="hidden" id="json-report-period" value="1W">
				  <input type="hidden" id="json-report-from" value="0">
				  <input type="hidden" id="json-report-to" value="0">
				</td>
			</tr>
			<!-- tr style="display:none" -->
			<tr>
				<td width="125" style="vertical-align: top;"><label for="json-report-scheduled_time_filter">Scheduled Time Filter:</label></td>
				<td>
					<select id="json-report-scheduled_time_filter">
						<option value=0 checked>Always</option>
<%
	Iterator itperiod = allPeriodList.iterator();
	while(itperiod.hasNext()) {
	HashMap dict = (HashMap)itperiod.next();
//	int periodID = (Integer)dict.get("PeriodID");
	String periodName = (String)dict.get("PeriodName");
	String periodTime = (String)dict.get("PeriodTime");
	//String periodDesc = (String)dict.get("Description");
%>
			<option value="<%=periodTime%>"><%=periodName%></option>
<%}%>
						<!-- option value=1>Work Time</option -->
						<!-- option value=2>Leisure Time</option -->
					</select>
				</td>
			</tr>
		<tr>
		<td width="125" style="vertical-align: top"><label for="json-report-device_group">Device Group</label></td>
		<td>
			<select id="json-report-device_group" style="width:100px;">
			<option value="">All</option>
					</select>
				</td>
			</tr>
			<tr>
				<td width="110" style="vertical-align: top;"><label for="json-report-type">Report Output:</label></td>
				<td>
					<select id="json-report-type">
						<option value="PDF" selected>PDF</option>
						<option value="HTML">HTML</option>
						<option value="CSV">CSV</option>
					</select>
				</td>
			</tr>
			<tr>
				<td width="110" style="vertical-align: top;"><label for="json-report-list_number">Saved Reports:</label></td>
				<td>
					Save up N reports
					<select id="json-report-list_number">
						<option value="1">1</option>
						<option value="5">5</option>
						<option value="10" selected>10</option>
						<option value="20">20</option>
						<option value="30">30</option>
						<option value="40">40</option>
						<option value="50">50</option>
						<option value="60">60</option>
						<option value="70">70</option>
						<option value="80">80</option>
						<option value="90">90</option>
						<option value="99">99</option>
					</select>
				</td>
			</tr>
		</table>
	</td>
</tr>
<tr>
	<td width="538" class="tableheadergrey2">
		<input type="checkbox" id="json-report-mail_enable"/>
		<label for="json-report-mail_enable">Email This Report</label>
	</td>
</tr>
<tr>
	<td>
		<table border="0" cellspacing="2" cellpadding="2">
			<tr>
				<td width="110"><label for="json-report-mail_from">From:</label></td>
				<td><input type="text" class="button" id="json-report-mail_from"/></td>
			</tr>
			<tr>
				<td width="110"><label for="report_mail_to">Recipients:</label></td>
				<td><input type="text" class="button" id="report_mail_to"/></td>
			</tr>
			<tr>
				<td width="110"><label for="json-report-subject">Subject:</label></td>
				<td><input type="text" class="button" id="json-report-subject"/></td>
			</tr>
			<tr>
				<td	 width="110" style="vertical-align:top;"><label for="json-report-message">Message:</label></td>
				<td><textarea class="button" id="json-report-message" rows="3"></textarea></td>
			</tr>
			<tr>
				<td colspan="2">
					<input type="checkbox" id="json-report-mail_attach"/>
					<label for="json-report-mail_attach">Include report as Attachment (Optional)</label>
				</td>
			</tr>
			<tr>
				<td colspan="2" style="vertical-align:top;padding-top:5px;margin-top:5px;border-top:1px solid #CCC;">
					<input type="checkbox" id="json-report-fail_notice"/>
					<label for="json-report-fail_notice">Failure Notice: Notify if email message cannot be
								   delivered (optional)</label>
				</td>
			</tr>
			<tr>
				<td width="110"><label for="report_fail_mail_to">Recipients:</label></td>
				<td><input type="text" class="button" id="report_fail_mail_to"/></td>
			</tr>
		</table>
	</td>
</tr>
<tr>
	<td width="538" class="tableheadergrey2">Report By</td>
</tr>
<tr>
	<td>
		<table border="0" cellspacing="2" cellpadding="2">
			<tr>
				<td>
					<div style="position:relative;"><input type="radio" id="report_by_0" name="json-report-report_by" value="0" checked/>
					  <label for="report_by_0">All Users</label>
					</div>
					<div style="position:relative;">
						<input type="radio" name="json-report-report_by" id="report_by_1" value="1"/>
						<label for="report_by_1">Specific Users / Groups</label>
						<input type="hidden" id="report_selected_users">
					</div>
				  <form style="padding-left:20px;display:none;" name="saveform">
				  <input name="loginendusers" type="hidden" class="button" value='<%=roleinfo.getEndUsers()%>'>
				  <table border="0" cellpadding="0" cellspacing="0" class="border">
				  <tbody>
				  <tr>
					  <td valign="top">
						  <table width="285" border="0" cellpadding="0" cellspacing="0">
							<tbody>
							  <tr>
								  <td colspan="4" class="data1">Users / Groups:</td>
							  </tr>
							  <tr>
								  <td>&nbsp;</td>
								  <td class="data1">Search:</td>
								  <td class="data1">
									  <input name="keyword" id="keyword" type="text" class="button" value="" size="20"
											 maxlength="256">
								  </td>
								  <td class="data1">
									  <input name="search" type="button" class="button"
											 onclick="javascript:doLDAPSearch();" value="Search"
											 style="width:55px">
								  </td>
							  </tr>
							</tbody>
						  </table>
						  <table border="0" style="border-bottom: 1px solid #CCC;">
							  <tr>
								  <td valign="top" colspan="4">
									  <div id="object1"
										   style="position:absolute; background-color:white;color:black;border-color:black;border-width:20; visibility:show; left:25px; top:-50px; z-index:+1"
										   onmouseover="overdiv=1;"
										   onmouseout="overdiv=0; setTimeout('hideLayer()',1000)"></div>
									  <table border="0" cellpadding="0" cellspacing="0">
										  <tbody>
										  <tr>
											<td>
											  <div id="account_list" class="clearfix">
												<ul class="left_list" tabindex="0" unselectable="on"></ul>
												<div class="actions"></ul>
												  <input tabindex="0" id="AddUsers" type="button" class="button" value=">" />
												  <input tabindex="0" id="AddAllUsers" type="button" class="button" value=">>" />
												  <input tabindex="0" id="RemoveAllUsers" type="button" class="button" value="<<" />
												  <input tabindex="0" id="RemoveUsers" type="button" class="button" value="<" />
												</div>
												<ul class="right_list" tabindex="0" unselectable="on"></ul>
											  </div>
											</td>
										  </tr>
										  <tr>
											  <td height="10"><img src="images/1space.gif" width="1"
																			   height="10"></td>
										  </tr>
										  </tbody>
									  </table>
								  </td>
							  </tr>
						  </table>
						  <table>
							<tbody>
							  <tr>
								  <td height="22" colspan="2" class="data1">
									  <div>IP:</div>
								  </td>
								  <td width="106" height="22" class="data1">
									  <div align="right">
										  <input name="ipadd" type="text" class="button" size="20"
												 onkeypress="return handleEnter(this, event)">
									  </div>
								  </td>
								  <td width="61" height="22" class="data1">
									  <div align="right">
										  <input name="addip" type="button" class="button" onclick="javascript:AddIP();"
												 value="Add" style="width:55px">
									  </div>
								  </td>
							  </tr>
							  <tr>
								  <td height="22" colspan="2" class="data1">IP range:</td>
								  <td height="22" class="data1">&nbsp;</td>
								  <td height="22" class="data1">&nbsp;</td>
							  </tr>
							  <tr>
								  <td width="30" height="22" class="data1">&nbsp;</td>
								  <td width="108" class="data1">From:</td>
								  <td height="22" class="data1">
									  <div align="right">
										  <input name="fromadd" type="text" class="button" size="20">
									  </div>
								  </td>
								  <td height="22" class="data1">&nbsp;</td>
							  </tr>
							  <tr>
								  <td height="22" class="data1">&nbsp;</td>
								  <td height="22" class="data1">To:</td>
								  <td height="22" class="data1">
									  <div align="right">
										  <input name="toadd" type="text" class="button" size="20">
									  </div>
								  </td>
								  <td height="22" class="data1">
									  <div align="right">
										  <input name="addrange" type="button" class="button"
												 onclick="javascript:AddRange();" value="Add" style="width:55px">
									  </div>
								  </td>
							  </tr>
							  <tr>
								  <td height="5" colspan="4"><img src="images/1space.gif" width="1" height="10"></td>
							  </tr>
							  <tr>
								  <td colspan="3" class="data1">IP Subset:</td>
							  </tr>
							  <tr>
								  <td width="27">&nbsp;</td>
								  <td width="50" class="data1">Address:</td>
								  <td width="188"><input name="ipv6address" type="text" class="button" size="20"
														 maxlength="40"></td>
							  </tr>
							  <tr>
								  <td>&nbsp;</td>
								  <td class="data1">Prefix Length:</td>
								  <td><input name="ipv6mask" type="text" class="button" size="20" maxlength="20"></td>
								  <td><input name="addrange" type="button" class="button"
											 onclick="javascript:AddIPv6Mask();" value="Add" style="width:55px">
								  </td>
							  </tr>
							  <tr>
								  <td height="1" colspan="4"><img src="images/1space.gif" width="1"
																  height="5"></td>
							  </tr>
							</tbody>
						  </table>
						  <div style="max-height: 100px; overflow: auto;border: 1px solid #CCC; display: inline-block; margin: 10px;" class="border">
							<table border="0" cellpadding="0" cellspacing="0" id="EntityTable" class="border">
							  <tbody>
								<tr>
									<td width="71" height="22" class="grey">Type</td>
									<td width="164" height="22" class="grey">Identification</td>
									<td width="26" height="22" class="grey-end">&nbsp;</td>
								</tr>
							  </tbody>
							</table>
						  </div>
					  </td>
				  </tr>
				  <tr>
					<td>&nbsp;</td>
				  </tr>
				  </tbody>
				  </table>
				  </form>
				</td>
			</tr>
		</table>
	</td>
</tr>
<tr>
	<td width="538" class="tableheadergrey2">Report Types</td>
</tr>
<tr>
	<td>
		<table border="0" cellspacing="2" cellpadding="2">
			<tr>
				<td width="700">
					<div id="report_selector" class="dynatree"></div>
				</td>
			</tr>
		</table>
	</td>
</tr>
<tr>
	<td><img src="images/1space_cui.gif" width="1" height="10"></td>
</tr>
</tbody>
</table>
</td>
</tr>
</tbody>
</table>
<div style="padding:10px 0 50px;">
	<%=AccessLevel.BUTTON_REPORT(request, response, "save_report", "Save Report")%>
	&nbsp;
	<%=AccessLevel.BUTTON_REPORT(request, response, "cancel", "Cancel")%>
</div>
<br/>
<br/>

<script language="JavaScript" type="text/javascript" src="lib/tmPlugins/jquery-1.8.3.min.js"></script>
<script language="JavaScript" type="text/javascript" src="./log/js/date.js"></script>
<script language="JavaScript" type="text/javascript" src="./log/page/timezone.jsp"></script>
<script type="text/javascript">
	timezoneJS.timezone.zoneFileBasePath = "./log/js/tz/";
	var zoneFile = 'america';
	if (currentTimeZone) {
		var zf = currentTimeZone.split("/");
		zoneFile = zf[0].toLowerCase();
	}
  timezoneJS.timezone.defaultZoneFile = zoneFile;
  timezoneJS.timezone.init({async: false});
</script>
<script language="JavaScript" type="text/javascript" src="lib/data/lang.js"></script>
<script language="JavaScript" type="text/javascript" src="lib/tmPlugins/jquery-ui-1.9.2.custom.min.js"></script>
<script language="JavaScript" type="text/javascript" src="lib/tmPlugins/jquery-ui-timepicker-addon.js"></script>
<script language="JavaScript" type="text/javascript" src="lib/tmPlugins/jquery-ui-timepicker-addon-plus.js"></script>
<script language="JavaScript" type="text/javascript" src="lib/tmPlugins/jquery.dynatree.min.js"></script>
<script language="JavaScript" type="text/javascript" src="lib/tmPlugins/jquery.cookie.js"></script>
<script language="JavaScript" type="text/javascript" src="lib/tmPlugins/json2.min.js"></script>
<script language="JavaScript" type="text/javascript" src="lib/tmPlugins/i18n.js"></script>

<script language="JavaScript" type="text/javascript" src="lib/data/common_functions.js"></script>
<script language="JavaScript" type="text/javascript" src="lib/data/report_action.js"></script>
<script language="JavaScript" type="text/javascript" src="lib/data/select_users_groups.js"></script>
<script language="JavaScript" type="text/javascript" src="html/func.js" ></script>
<script language="JavaScript" type="text/javascript" src="html/i18n_warnmsg.js"></script>
<script language="JavaScript" type="text/javascript" src="html/check.js"></script>

<script language="JavaScript" type="text/javascript">
	$(document).ready(function() {
		localizePage("report_action");
		$("#cancel").click(function() {
			document.location.href = "./reports.jsp";
		});

		$(".btnSelect").click(function() {
			var timeRangeLabel = $(".range_start").html() + " | " + $(".range_end").html();
			$(".timeRangeLabel").html(timeRangeLabel);
		});

	});
</script>
</body>
</html>
