#!/usr/env python

import sys
from os import system
import time
import ConfigParser

UPDATE_RESOURCE = {
                #"file name which need to be update": ["full path of the target file", "right", "owner:group"],
                "S99ISsocks5": [" /usr/iwss/", " iscan:iscan", " 755"],
                "convert_socks_setting.py": [" /usr/iwss/", " iscan:iscan", " 755"],
                "antinat.xml.bak": [" /etc/", " iscan:iscan", " 755"],
                "antinat.xml.allow": [" /etc/", " iscan:iscan", " 755"],
                "antinat.xml.reject": [" /etc/", " iscan:iscan", " 755"],
}

STOP_SERVICE = ["/etc/iscan/S99ISsocks5"]
START_SERVICE = ["/etc/iscan/S99ISsocks5"]

#backup the binary
def backup_binary():

    backup_folder = " ./backup_" + str(int(time.time()))
    mkdir_cmd = " mkdir" + backup_folder
    print "start mkdir_cmd: " + mkdir_cmd
    call_system(mkdir_cmd)

    for target in UPDATE_RESOURCE:
       cp_cmd = " /bin/cp -rf" 
       cp_cmd = cp_cmd + UPDATE_RESOURCE[target][0] + target + backup_folder
       print "start cp_cmd: " + cp_cmd
       call_system(cp_cmd)

#install the rpm package in this folder
def install_rpm():
    
    install_cmd = "rpm -ivh *.rpm"
    print "start rpm install cmd: " + install_cmd
    call_system(install_cmd)

#update the binary
def update_binary():
    for target in UPDATE_RESOURCE:
       cp_cmd = " /bin/cp -rf " 
       cp_cmd = cp_cmd + target + UPDATE_RESOURCE[target][0]
       print "start cp_cmd: " + cp_cmd
       call_system(cp_cmd)

       chown_cmd = " chown "
       chown_cmd = chown_cmd + UPDATE_RESOURCE[target][1] + UPDATE_RESOURCE[target][0] + target
       print "start chown_cmd: " + chown_cmd
       call_system(chown_cmd)


       chmod_cmd = " chmod"
       chmod_cmd = chmod_cmd + UPDATE_RESOURCE[target][2] + UPDATE_RESOURCE[target][0] + target
       print "start chmod_cmd: " + chmod_cmd
       call_system(chmod_cmd)

#update the configuration
def update_ini():
    #backup ini at first
    CONFIG_FILE = "/etc/iscan/intscan.ini"
    cp_ini_cmd = "cp " + CONFIG_FILE + " backup_*"
    print "start cp_ini_cmd: " + cp_ini_cmd
    call_system(cp_ini_cmd)

    config = ConfigParser.RawConfigParser()
    config.read(CONFIG_FILE)
    config.set("notification", "use_auth", "no")
    config.set("notification", "use_ssl", "yes")
    config.set("notification", "auth_password", "")

    with open(CONFIG_FILE, "wb") as configefile:
        config.write(configefile)

#restart service
def start_service():
    for service in START_SERVICE:
       start_cmd = service + ' start'
       print "start start_cmd: " + start_cmd
       call_system(start_cmd)
      
def stop_service():
    for service in STOP_SERVICE:
       stop_cmd = service + ' stop'
       print "start stop_cmd: " + stop_cmd
       call_system(stop_cmd)

def print_usage():
    print "usage: ./apply_debug_module.py apply"

def call_system(cmd):
    system(cmd)
    pass

if __name__ == "__main__":
    if len(sys.argv) != 2 or sys.argv[1] != "apply":
        print_usage()

    else:
        backup_binary()
        stop_service()
        update_binary()
        install_rpm()
        start_service()

